

/***********************************************************
** action.pl
***********/


/* ------------------------------------------------
   Action du mineur */

   %  action(Map, PosMineur, CanGotoExit, Mouvement)

% Le mineur ralise une action prdfinie
action(Map, PosMineur, CanGotoExit, Mouvement)
:- recorded(performingAction, true),                              % /SI\ Une action est en cours
   recorded(currentAction, Action),                               % On rcupre le script de l'action
   doAction(Action, Map, PosMineur, CanGotoExit, Mouvement), !.   % On execute le prochain pas de l'action
   
% un chemin est en cours
action(NavMap, PosMineur, CanGotoExit, Mouvement)
:- recorded(way, [ToGo | Way]),
   save(way, Way),
   save(canGotoExit, CanGotoExit),
   casesToDirection(PosMineur, ToGo, Mouvement),
   newPosFromMovment(PosMineur, Mouvement, NewPos),
   mapNavigateTo(NavMap, PosMineur, TempMap1),
   getCurrentCaseInNavMap(TempMap1, Case),
   changeCaseType(Case, 1, NewCase),
   setCurrentCaseInNavMap(TempMap1, NewCase, TempMap2),
   mapNavigateTo(TempMap2, NewPos, TempMap3),
   getCurrentCaseInNavMap(TempMap3, Case3),
   not(getCaseType(Case3, no_way)),
   not(notSafeCase(TempMap3)),
   saveMinorOldPos(PosMineur),
   debugN('saved way'), !.
   %goTo(NavMap, CloserTarget, true, Mouvement), !.   % on se dplace
   
   
   
% Ralise une action sur la carte (on n'a pas encore assez de diamants)
action(NavMap, PosMineur, 0, Mouvement)
:- getCloserTarget(NavMap, PosMineur, CloserTarget), % on rcupre la cible la plus proche

   debug('best target :'), debugN(CloserTarget),
   
   save(canGotoExit, 0),
   
   mapNavigateTo(NavMap, PosMineur, NewNavMap),
   pathFinding(NewNavMap, CloserTarget, [ _, ToGo| Way]),
   
   save(way, Way),
   
   %debugN(PosMineur),
   
   casesToDirection(PosMineur, ToGo, Mouvement),
   saveMinorOldPos(PosMineur), !.
   
   %debug(M), !.
   %goTo(NavMap, CloserTarget, true, Mouvement), !.   % on se dplace
   



   
% Ralise une action sur la carte (on trace vers la sortie)
action(NavMap, PosMineur, 1, Mouvement)
:- getExitPos(NavMap, Exit), % on rcupre la sortie

   save(canGotoExit, 1),

   mapNavigateTo(NavMap, PosMineur, NewNavMap),
   pathFinding(NewNavMap, Exit, [ _, ToGo| Way], false, false),
   
   save(way, Way),

   casesToDirection(PosMineur, ToGo, Mouvement),
   saveMinorOldPos(PosMineur), !.
   
   

/*% Ralise une action sur la carte
action(NavMap, PosMineur, CanGotoExit, Mouvement)
:- %preTraitementAdjacentMap(Map, PosMineur, NewMap),              % traitement des obstacles adjacents
   %getNavigateMap(Map, [1, 1], NavigationMap),                    % get navigation Map
   getCloserTarget(NavMap, PosMineur, CloserTarget),              % on rcupre la cible la plus proche
   goTo(NavMap, CloserTarget, CanGotoExit, Mouvement), !.         % on se dplace   */


/***********************************************************
** basic.pl
***********/


/* ------------------------------------------------
   Les 2 positions sont adjacentes ou confondues */

   % isNear(Pos1, Pos2)

isNear([X,Y1],[X,Y2]):- voisin(Y1,Y2), !.
isNear([X1,Y],[X2,Y]):- voisin(X1,X2), !.

voisin(A,A):- !.
voisin(A,B):- A is B+1, !.
voisin(A,B):- A is B-1, !.


/* ------------------------------------------------
   Distance entre deux positions */

   % getDist(Pos1, Pos2, Dist)

getDist([X1, Y1], [X2, Y2], Dist) :- Dist is (abs(X1 - X2) + abs(Y1 - Y2)).


/* ------------------------------------------------
   Vrai si Pos est une position */

   % isPosition(Pos)
   
isPosition([_, _]).


/* ------------------------------------------------
   Ajoute un element dans une liste trie de manire croissante */

   % addInAscOrderedList(Element, CurrentList, NewList)


% Si le poid du nouvel element est superieur  celui de l'element courrant, l'insere plus loin
addInAscOrderedList([NewWeigth, NewElement], [[Weigth, Element] | List], [[Weigth, Element] | NewList])
:- NewWeigth > Weigth,
   addInAscOrderedList([NewWeigth, NewElement], List, NewList), !.

% Si le poid du nouvel element est infrieur ou gal  celui de l'element courrant, l'inserer devant
addInAscOrderedList([NewWeigth, NewElement], [[Weigth, Element] | List], [[NewWeigth, NewElement], [Weigth, Element] | List])
:- NewWeigth =< Weigth, !.

% Si la liste est vide, on y met juste l'element
addInAscOrderedList(Element, [], [Element]):- !.


/* ------------------------------------------------
   get list size */
   
   % getListSize(List, Size)

getListSize([], 0).
getListSize([_|R], NB) :- getListSize(R, RNB), NB is RNB + 1.


saveMinorOldPos(Pos)
:- save(oldMineurPosition, Pos), !.



save(Key, Value)
:- recorded(Key, _, Reference),
   erase(Reference),
   recorda(Key, Value), !.

save(Key, Value)
:- recorda(Key, Value), !.




/* ------------------------------------------------
   essais d'aller du point Start au point Go, en ligne droite */
   
   % casesToDirection(Start, Go, Move)

casesToDirection([X, _], [Xgo,  _ ], [ 1,  0]) :- X < Xgo, !.
casesToDirection([X, _], [Xgo,  _ ], [-1,  0]) :- X > Xgo, !.
casesToDirection([_, Y], [ _ , Ygo], [ 0,  1]) :- Y < Ygo, !.
casesToDirection([_, Y], [ _ , Ygo], [ 0, -1]) :- Y > Ygo, !.

casesToDirection(_, _, [ 0, 0]) :- !.



/* ------------------------------------------------
   Down est juste en dessous de Pos */

   % isJustUpper(Pos, Down)
   
   
isJustUpper([X, Y1], [X, Y2]) :- Y2 = Y1 + 1, !.


newPosFromMovment([X, Y], [DX, DY], [NX, NY])
:- NX is X + DX, NY is Y + DY, !.



/* ------------------------------------------------
   Prdiccats de dbug */

debugN( T ) :- open( 'trace.txt', append, L ), write( L, T ), nl( L ), close( L ).
debug( T )  :- open( 'trace.txt', append, L ), write( L, T ), write( L, ' '), close( L ).


debugN_fct(_)   :- !.
debug_fct(_)    :- !.

debugN_fct( T ) :- debugN(T).
debug_fct( T )  :- debug(T).

debugN_pf(_)   :- !.
debug_pf(_)    :- !.

debugN_pf( T ) :- debugN(T).
debug_pf( T )  :- debug(T).

debugN_mm(_)   :- !.
debug_mm(_)    :- !.

debugN_mm( T ) :- debugN(T).
debug_mm( T )  :- debug(T).



/***********************************************************
** findCloserTarget.pl
***********/


/* ------------------------------------------------
   get the closer target position */

   % getCloserTarget(NavigableMap, Pos, CloserTarget)
   % getCloserTarget(NavigableMap, Pos, CloserTarget, AllFoundedTargets, BestDist)
   
% essai : dealList([1, 1, 1, 1, 1, 1, 1, 2, 1], 3, M), getNavigateMap(M, [1, 1], NM), getCloserTarget(NM, [1, 1], Target).

getCloserTarget(Map, Pos, CloserTarget)
:- mapNavigateTo(Map, Pos, NewMap),
   debugN_fct('-------------'),
   getCloserTarget(NewMap, NewMap, Pos, CloserTarget, [100000, 100000]), !.


% Si on est plus  gauche de la  case d'origine que la meilleur distance, pas la peine de continuer, on passe  la ligne du dessous
getCloserTarget(OriginMap, NavMap, [OX, OY], CloserTarget, BestPos)
:- getDist([OX, OY], BestPos, BestDist),
   getCurrentCasePosInNavMap(NavMap, [CX, _]),
   (CX - OX) > BestDist,
   debugN_fct('trop  gauche'),
   getCloserTarget_nextLine(OriginMap, NavMap, [OX, OY], CloserTarget, BestPos), !.

% On doit tester la case
getCloserTarget(OriginMap, NavMap, OPos, CloserTarget, BestPos)
:- getCurrentCaseAndPosInNavMap(NavMap, Case, [X, Y]),
   debug_fct('test case : '), debug_fct(X), debug_fct(' '), debug_fct(Y), debug_fct(' : '), getCaseType(Case, TT), debugN_fct(TT),
   getCloserTarget_addCase(Case, OPos, [X, Y], BestPos, NewBestPos),
   getCloserTarget_nextCase(OriginMap, NavMap, OPos, CloserTarget, NewBestPos), !.



% Si on est plus  gauche de la  case d'origine que la meilleur distance, pas la peine de continuer, on passe  la ligne du dessus
getCloserTargetReverse(OriginMap, NavMap, [OX, OY], CloserTarget, BestPos)
:- getDist([OX, OY], BestPos, BestDist),
   getCurrentCasePosInNavMap(NavMap, [CX, CY]),
   (OX - CX) > BestDist,
   debugN_fct('trop  droite : '), debugN_fct([CX, CY]),
   getCloserTarget_previousLine(OriginMap, NavMap, [OX, OY], CloserTarget, BestPos), !.

% On doit tester la case
getCloserTargetReverse(OriginMap, NavMap, OPos, CloserTarget, BestPos)
:- getCurrentCaseAndPosInNavMap(NavMap, Case, Pos),
   debug_fct('test case : '), debug_fct(Pos), debug_fct(' : '), getCaseType(Case, TT), debugN_fct(TT),
   getCloserTarget_addCase(Case, OPos, Pos, BestPos, NewBestPos),
   getCloserTarget_previousCase(OriginMap, NavMap, OPos, CloserTarget, NewBestPos), !.




% Si on est plus bas de la case d'origine que la meilleur distance, pas la peine de descendre plus bas, on va chercher en haut
getCloserTarget_nextLine(OriginMap, NavMap, [OX, OY], CloserTarget, BestPos)
:- getDist([OX, OY], BestPos, BestDist),
   getCurrentCasePosInNavMap(NavMap, [_, CY]),
   (CY - OY) > BestDist,
   debugN_fct('on est trop bas'),
   getCloserTargetReverse(OriginMap, OriginMap, [OX, OY], CloserTarget, BestPos), !.

% Sinon on va a la ligne suivante
getCloserTarget_nextLine(OriginMap, NavMap, OPos, CloserTarget, BestPos)
:- getNextLineInNavMap(NavMap, NewNavMap),
   debugN_fct('on va a la ligne suivante'),
   getCloserTarget(OriginMap, NewNavMap, OPos, CloserTarget, BestPos), !.

% S'il n'y a pas de ligne suivante on cherche vers le haut
getCloserTarget_nextLine(OriginMap, _, OPos, CloserTarget, BestPos)
:- debugN_fct('fin de carte'), getCloserTargetReverse(OriginMap, OriginMap, OPos, CloserTarget, BestPos), !.



% Si on est plus haut de la case d'origine que la meilleur distance, pas la peine de monter plus haut, on arrete de chercher
getCloserTarget_previousLine(_, NavMap, [OX, OY], BestPos, BestPos)
:- getDist([OX, OY], BestPos, BestDist),
   getCurrentCasePosInNavMap(NavMap, [_, CY]),
   (OY - CY) > BestDist, !.

% Sinon on va a la ligne precedente
getCloserTarget_previousLine(OriginMap, NavMap, OPos, CloserTarget, BestPos)
:- getPreviousLineEndInNavMap(NavMap, NewNavMap),
   getCloserTargetReverse(OriginMap, NewNavMap, OPos, CloserTarget, BestPos), !.

% S'il n'y a pas de ligne precedente, on a fini
getCloserTarget_previousLine(_, _, _, BestPos, BestPos) :-  !.



% On va a la case suivante si on peut
getCloserTarget_nextCase(OriginMap, NavMap, OPos, CloserTarget, BestPos)
:- getNextCaseInNavMap(NavMap, NewNavMap),
   debugN_fct('ok next'),
   getCloserTarget(OriginMap, NewNavMap, OPos, CloserTarget, BestPos), !.

% sinon on va a la ligne suivante
getCloserTarget_nextCase(OriginMap, NavMap, OPos, CloserTarget, BestPos)
:- debugN_fct('fail next'),
   getCloserTarget_nextLine(OriginMap, NavMap, OPos, CloserTarget, BestPos), !.



% On va a la case prcdente si on peut
getCloserTarget_previousCase(OriginMap, NavMap, OPos, CloserTarget, BestPos)
:- getPreviousCaseInNavMap(NavMap, NewNavMap),
   getCloserTargetReverse(OriginMap, NewNavMap, OPos, CloserTarget, BestPos), !.

% sinon on va a la ligne prcdente
getCloserTarget_previousCase(OriginMap, NavMap, OPos, CloserTarget, BestPos)
:- getCloserTarget_previousLine(OriginMap, NavMap, OPos, CloserTarget, BestPos), !.





% Si la case est un objectif et plus pret que l'obj courant, changer la position de l'obj courant
getCloserTarget_addCase(Case, Origin, [X, Y], BestPos, [X, Y])
:- caseIsTarget(Case),
   getCaseType(Case, Type),
   debug_fct('case type : '),
   debugN_fct(Type),
   debug_fct('on ajoute la case : '),
   debug_fct(X),
   debug_fct(' '),
   debugN_fct(Y),
   getDist(Origin, [X, Y], Dist),
   getDist(Origin, BestPos, BestDist),
   Dist < BestDist, !.

% Sinon la nouvelle position n'a pas chang
getCloserTarget_addCase(_, _, _, BestPos, BestPos) :- !.


/***********************************************************
** main.pl
***********/


% on dfinit le primtre de vue  0, on voit toute la carte
setViewPerimeter(0, 0).

/* ------------------------------------------------
   Prdicat gnral */

   %  move(L, X, Y, Pos, Size, CanGotoExit, Dx, Dy)
   % L : map list
   % X, Y : miner coordinates
   % Pos : miner position in the map list
   % Size : map width
   % CanGotoExit : 1 if miner can leave map
   % Dx : miner next horizontal move
   % Dy : miner next vertical move


% On doit traiter toute la carte
move(L, X, Y, _, Size, _, 0, 0)
:- mustDealMap([X, Y], Size),            % /SI\ on doit traiter la carte
   debug('mineur : '), debug(X), debug(' '), debugN(Y),
   debugN('====== first deal'),
   dealList(L, Size, Map),               % on traite la carte
   debugN('dealed'),
   save(mustDealMap, false),             % on dit que la carte ne doit plus tre traite en premier passage
   save(mapHasMoved, true),              % on dit que la carte a boug cette image et que l'on va devoir anticiper les mouvements de la carte
   debugN('recorded'),
   saveMap(Map),                         % on enregistre la carte traite
   debugN('saved'),
   save(mustRedealMap, true),            % on doit faire un second passage sur la map
   save(way, []),
   saveMinorOldPos([X,Y]), !.

 % On doit retraiter toute la carte
move(L, X, Y, _, _, CanGotoExit, Dx, Dy)
:- recorded(mustRedealMap, true),   % /SI\ on doit retraiter la carte
   debugN('====== second deal'),
   loadMap(OldMap),                 % on rcupre la map de l'image prcdente
   debugN('loaded'),
   %redealMap(L, OldMap, Map),       % on traite la carte completement ( deuxime passage )
   updateMap(L, OldMap, Map),       % on traite la carte completement ( deuxime passage )
   debugN('updated'),
   save(mustRedealMap, false),      % on dit que la carte ne doit plus tre traite
   debugN('recorda'),
   %actionMiniThenFull(Map, [X, Y], CanGotoExit, [Dx, Dy]), !.
   action(Map, [X, Y], CanGotoExit, [Dx, Dy]),
   debugN('actioned'), !.

% Dans les autres cas
 move(L, X, Y, _, _, CanGotoExit, Dx, Dy)
 :- debugN('====== other deal'),
    loadMap(OldMap),                % on rcupre la map
    updateMap(L, OldMap, Map),      % on actualise la map
    %actionMiniThenFull(Map, [X, Y], CanGotoExit, [Dx, Dy]), !.
    action(Map, [X, Y], CanGotoExit, [Dx, Dy]), !.
    
    


/***********************************************************
** mapChange.pl
***********/


/* ------------------------------------------------
   Permet de savoir si le joueur s'est dplac sans IA ou si la carte a chang */

   %  mapHasChanged(PosMineur, LargeurCarte)

% Si on ne connait pas la position du mineur, la carte a chang (on lance l'IA pour la premire fois de la session)
mapHasChanged(_, _) :- not(recorded(oldMineurPosition, _)), debugN('on ne connait pas la position du mineur'), !.

% Si le mineur s'est loign de plus d'une case de son ancienne position, la carte a chang
mapHasChanged(PosMineur, _)
:- recorded(oldMineurPosition, OldMineurPosition),
   debug('ancienne pos :'),
   debugN(OldMineurPosition),
   debug('nouvelle pos :'),
   debugN(PosMineur),
   not(isNear(OldMineurPosition, PosMineur)), debugN('le mineur s''est trop dplac'), !.

% Si on n'a pas de carte enregistre, la carte a chang
mapHasChanged(_, _) :- not(recorded(map, _)), debugN('on n''a pas de carte enregistr'), !.

% Si la carte a chang de largeur, elle a chang
mapHasChanged(_, Size)
:- getMapSize([Largeur, _]),
   Largeur \= Size,
   debug('la largeur a chang :'), debugN(Largeur), !.

% Si la carte a chang de hauteur, elle a chang
% ne peut pas etre su si facilement ... pas grave
% on estime que les cas prcdents suffisent pour savoir si la carte a chang


/* ------------------------------------------------
   Permet de savoir si on arriver sur une nouvelle carte, ou si on s'est dplac manuellement */

   % mustDealMap(MinerPos, Width)

mustDealMap(_, _)
:- recorded(mustDealMap, true), debugN('mustDealMap is true'), !.

mustDealMap(MinerPos, Width)
:- mapHasChanged(MinerPos, Width), debugN('mapHasChanged is true'), !.


/***********************************************************
** mapFormat.pl
***********/


/* ------------------------------------------------
   Traite une carte pour la mettre dans notre format */

   % dealList(List, Width, Map)
   % dealList(List, RestInCurrentWidth, RealWidth, Map, CurrentLineNumber)
   
   
   
% essai : dealList([2, 1, 1, 1, 1, 1, 1, 1, 1], 3, M).

% rappel de la fonction avec un parametre en plus
dealList(List, Width, NavigationMap)
:- dealList(List, Width, Width, SimpleMap, 1),
   getNavigateMap(SimpleMap, [0,0], TempNavMap),
   dealMap(TempNavMap, NavigationMap), !.

% on a fini la ligne
dealList([Type|List], 1, Width, [[[TypeCase, no_blocked, Type, false]]|Map], Height)
:- getCaseTypeFromInt(Type, TypeCase),
   NewHeight is Height + 1,
   dealList(List, Width, Width, Map, NewHeight), !.

% on traite une case quelconque
dealList([Type|List], Rest, Width, [[[TypeCase, no_blocked, Type, false]|Line]|Map], Height)
:- getCaseTypeFromInt(Type, TypeCase),
   NewRest is Rest - 1,
   dealList(List, NewRest, Width, [Line|Map], Height), !.

% On a rcupr
dealList([], _, Width, [], Height) :- NewHeight is Height - 1, recorda(mapSize, [Width, NewHeight]), !.

%dealList(L, _, _, _, _) :- debugN(L).


/* ------------------------------------------------
   Les diffrents types de cases */

   % getCaseType(Case, Type)

getCaseType([Type | _], Type).

getCaseRealType([_, _, CaseType | _], CaseType).


/* ------------------------------------------------
   Traite une carte ( cases interdites : monstres ... ) */

   %  dealMap(Map, NewMap)

% Prdicat pas encore fait ...
dealMap(Map, Map).


/* ------------------------------------------------
   vrai si la case est une cible */

   % caseIsTarget(Case)

caseIsTarget(Case) :- getCaseType(Case, diam), !.
%.............. TODO ................
% add other target kind


/* ------------------------------------------------
   Les diffrents types de cases */

   % getCaseTypeFromInt(Type, TypeCase)

getCaseTypeFromInt(0, vide).
getCaseTypeFromInt(1, terre).
getCaseTypeFromInt(2, diam).
getCaseTypeFromInt(3, pierre).
getCaseTypeFromInt(4, no_way).
getCaseTypeFromInt(5, vide).
getCaseTypeFromInt(6, no_way).
getCaseTypeFromInt(7, no_way).
getCaseTypeFromInt(8, no_way).
getCaseTypeFromInt(9, no_way).
getCaseTypeFromInt(16, monstre).
getCaseTypeFromInt(17, monstre).
getCaseTypeFromInt(20, no_way).
getCaseTypeFromInt(21, no_way).
getCaseTypeFromInt(22, exit).


/* ------------------------------------------------
   Ce type de terrain glisse */

isCaseTypeSlide(2). % diam
isCaseTypeSlide(3). % pierre

isCaseTypeSlide(6). % mur
isCaseTypeSlide(7). % mur
isCaseTypeSlide(8). % mur
isCaseTypeSlide(9). % mur

isCaseTypeSlide(20). % mur
isCaseTypeSlide(21). % mur


/* ------------------------------------------------
   Le mineur ne peut pas aller sur cette case */

   % notWalkableType(Type)

notWalkableType(no_way).
notWalkableType(monstre).
notWalkableType(exit) :- not(recorded(canGotoExit, 1)).



/* ------------------------------------------------
   tager la case comme non traite */
   
setCaseUnDealed([TypeCase, Blocked, Type, _ | R], [TypeCase, Blocked, Type, false | R]).

setCaseDealed([TypeCase, Blocked, Type, _ | R], [TypeCase, Blocked, Type, true | R]).

isCaseDealed([_, _, _, true | _]).

changeCaseType([_, Blocked, _ | R], Type, [TypeCase, Blocked, Type | R])
:- getCaseTypeFromInt(Type, TypeCase), !.


/* ------------------------------------------------
   On enregistre la carte */

   % saveMap(NavMap)

/*saveMap(_)
:- recorded(map, _, Reference),
   erase(Reference), !. */

saveMap(NavMap)
:- mapNavigateTo(NavMap, [0,0], OriginNavMap),
   save(map, OriginNavMap), !.
   
   
/* ------------------------------------------------
   On charge la carte */

   % loadMap(NavMap)

loadMap(NavMap)
:- recorded(map, NavMap), !.


/* ------------------------------------------------
   On rcupre la taille de la carte */

   % getMapSize([Width, Height])

getMapSize([Width, Height])
:- recorded(mapSize, [Width, Height]), !.


/* ------------------------------------------------
   On rcupre le monstre de la case */

   % getMonsterFromCase(Case, Monster)
   
getMonsterFromCase(Case, Monster).
%.............. TODO ................
% creer le prdicat


/* ------------------------------------------------
   On trouve la sortie de la carte */

   % getExitPos(Map, Pos)

getExitPos(Map, Pos)
:- mapNavigateTo(Map, [0,0], NewMap),
   getExitPos_(NewMap, Pos), !.
   
   
getExitPos_(Map, Pos)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, exit),
   getCurrentCasePosInNavMap(Map, Pos), !.
   
getExitPos_(Map, Pos)
:- getNextListCaseInNavMap(Map, NewMap),
   getExitPos_(NewMap, Pos), !.


/***********************************************************
** monster.pl
***********/



/* ------------------------------------------------
   Le monstre va vers le bas ou dans une direction inconue  */

   % monsterIsDownOrUnknown(Monster)

monsterIsDownOrUnknown(Monster).
%.............. TODO ................
% creer le prdicat


/* ------------------------------------------------
   Le monstre va vers le haut ou dans une direction inconue  */

   % monsterIsTopOrUnknown(Monster)

monsterIsTopOrUnknown(Monster).
%.............. TODO ................
% creer le prdicat


/* ------------------------------------------------
   Le monstre va vers la droite ou dans une direction inconue  */

   % monsterIsRightOrUnknown(Monster)

monsterIsRightOrUnknown(Monster).
%.............. TODO ................
% creer le prdicat


/* ------------------------------------------------
   Le monstre va vers la gauche ou dans une direction inconue  */

   % monsterIsLeftOrUnknown(Monster)

monsterIsLeftOrUnknown(Monster).
%.............. TODO ................
% creer le prdicat


/***********************************************************
** navigableMap.pl
***********/


/* ------------------------------------------------
   make a navigable map from a simple map */

   % getNavigateMap(Map, Pos, NavigationMap)
   
% essai : dealList([2, 1, 1, 1, 1, 1, 1, 1, 1], 3, M), getNavigateMap(M, [1, 1], NM).

getNavigateMap([[C| CR] | LR], Pos, NavigationMap)
:- mapNavigateTo([[0, 0], [], [], C, CR, LR], Pos, NavigationMap), !.


/* ------------------------------------------------
   Changer la case courante */
   
   % setCurrentCaseInNavMap(Map, NewCase, NewMap)

setCurrentCaseInNavMap([Pos, BeforeLines, BeforeCases, _ | R], Case, [Pos, BeforeLines, BeforeCases, Case | R]).



/* ------------------------------------------------
   Navigate on a navigable map */

   % mapNavigateTo([CurrentPos, BeforeLines, BeforeCases, CurrentCase, AfterCases, AfterLines], PosToGo, NavigationMap)

% il faut descendre
mapNavigateTo( [[_, Yc], BeforeLines, BeforeCases, CurrentCase, AfterCases, [ [FirstCase | NextCases] | AfterLines] ], [X, Y], NavigationMap)
:- Y > Yc,
   lineNavigateUnifyLine(BeforeCases, CurrentCase, AfterCases, Line),
   NewYc is Yc + 1,
   mapNavigateTo( [[0, NewYc], [Line | BeforeLines], [], FirstCase, NextCases, AfterLines], [X, Y], NavigationMap), !.


% il faut monter
mapNavigateTo( [[_, Yc], [[FirstCase | NextCases] | BeforeLines], BeforeCases, CurrentCase, AfterCases, AfterLines ], [X, Y], NavigationMap)
:- Y < Yc,
   lineNavigateUnifyLine(BeforeCases, CurrentCase, AfterCases, Line),
   NewYc is Yc - 1,
   mapNavigateTo( [[0, NewYc], BeforeLines, [], FirstCase, NextCases, [Line | AfterLines] ], [X, Y], NavigationMap), !.


% il faut aller a gauche
mapNavigateTo( [[Xc, Y], BeforeLines, [C | BeforeCases], CurrentCase, AfterCases, AfterLines ], [X, Y], NavigationMap)
:- X < Xc,
   NewXc is Xc - 1,
   mapNavigateTo( [[NewXc, Y], BeforeLines, BeforeCases, C, [CurrentCase| AfterCases], AfterLines ], [X, Y], NavigationMap), !.


% il faut aller a droite
mapNavigateTo( [[Xc, Y], BeforeLines, BeforeCases, CurrentCase, [C | AfterCases], AfterLines ], [X, Y], NavigationMap)
:- X > Xc,
   NewXc is Xc + 1,
   mapNavigateTo([[NewXc, Y], BeforeLines, [CurrentCase | BeforeCases], C, AfterCases, AfterLines ], [X, Y], NavigationMap), !.


% nous avons la case
mapNavigateTo([[X, Y] | R], [X, Y], [[X, Y] | R]) :- !.


/* ------------------------------------------------
   get a uniq line from navigation line */

   % lineNavigateUnifyLine(BeforeCases, CurrentCase, AfterCases, Line)


lineNavigateUnifyLine([T | BeforeCases], CurrentCase, AfterCases, Line)
:- lineNavigateUnifyLine(BeforeCases, T, [CurrentCase | AfterCases], Line), !.

lineNavigateUnifyLine([], Current, AfterCases, [Current | AfterCases]) :- !.


/* ------------------------------------------------
   get the current position of a navigate map */

   % getCurrentCasePosInNavMap(NavMap, Pos)

getCurrentCasePosInNavMap([Pos | _], Pos).


/* ------------------------------------------------
   get the current case and position of a navigate map */

   % getCurrentCaseAndPosInNavMap(NavMap, Case, Pos)

getCurrentCaseAndPosInNavMap([Pos, _, _, Case | _], Case, Pos).


/* ------------------------------------------------
   get the current case of a navigate map */

   % getCurrentCaseInNavMap(NavMap, Case, Pos)

getCurrentCaseInNavMap([ _, _, _, Case | _], Case).


/* ------------------------------------------------
   get the next line in a navigate map */

   % getNextLineInNavMap(NavMap, NewNavMap)

getNextLineInNavMap([ [X, Y] | NavMap], NewNavMap)
:- recorded(mapSize, [_, Height]),
   NewY is Y + 1,
   NewY < Height,
   mapNavigateTo([ [X, Y] | NavMap], [0, NewY], NewNavMap), !.


/* ------------------------------------------------
   get the previous line in a navigate map */

   % getPreviousLineInNavMap(NavMap, NewNavMap)

getPreviousLineInNavMap([ [X, Y] | NavMap], NewNavMap)
:- Y > 0,
   NewY is Y - 1,
   mapNavigateTo([ [X, Y] | NavMap], [0, NewY], NewNavMap), !.


/* ------------------------------------------------
   get the previous line in a navigate map and go to the end of line */

   % getPreviousLineEndInNavMap(NavMap, NewNavMap)

getPreviousLineEndInNavMap([ [X, Y] | NavMap], NewNavMap)
:- Y > 0,
   NewY is Y - 1,
   recorded(mapSize, [Width, _]),
   NewX is Width - 1,
   mapNavigateTo([ [X, Y] | NavMap], [NewX, NewY], NewNavMap), !.


/* ------------------------------------------------
   get the next case in a navigate map */

   % getNextCaseInNavMap(NavMap, NewNavMap)

getNextCaseInNavMap([ [X, Y] | NavMap], NewNavMap)
:- recorded(mapSize, [Weith, _]),
   NewX is X + 1,
   NewX < Weith,
   mapNavigateTo([ [X, Y] | NavMap], [NewX, Y], NewNavMap), !.
   


/* ------------------------------------------------
   get the next case in a navigate map, but go to the line instead of failing if we are at the end of the line */

   % getNextListCaseInNavMap(NavMap, NewNavMap)
   
getNextListCaseInNavMap(Map, NewMap)
:- getNextCaseInNavMap(Map, NewMap), !.

getNextListCaseInNavMap(Map, NewMap)
:- getNextLineInNavMap(Map, NewMap), !.


/* ------------------------------------------------
   get the previous case in a navigate map */

   % getPreviousCaseInNavMap(NavMap, NewNavMap)

getPreviousCaseInNavMap([ [X, Y] | NavMap], NewNavMap)
:- X > 0,
   NewX is X - 1,
   mapNavigateTo([ [X, Y] | NavMap], [NewX, Y], NewNavMap), !.
   
   
/* ------------------------------------------------
   get the next line in a navigate map with same X */

   % getNextLineSameXInNavMap(NavMap, NewNavMap)

getNextLineSameXInNavMap([ [X, Y] | NavMap], NewNavMap)
:- recorded(mapSize, [_, Height]),
   NewY is Y + 1,
   NewY < Height,
   mapNavigateTo([ [X, Y] | NavMap], [X, NewY], NewNavMap), !.
   

/* ------------------------------------------------
   get the previous line in a navigate map with same X */

   % getPreviousLineSameXInNavMap(NavMap, NewNavMap)

getPreviousLineSameXInNavMap([ [X, Y] | NavMap], NewNavMap)
:- Y > 0,
   NewY is Y - 1,
   mapNavigateTo([ [X, Y] | NavMap], [X, NewY], NewNavMap), !.
   
   
/* ------------------------------------------------
   se dplacer dans une direction donne */

   % mapNavigatePushTo(Map, Direction, NewMap)
   
mapNavigatePushTo(Map, up, NewMap)
:- getPreviousLineSameXInNavMap(Map, NewMap), !.

mapNavigatePushTo(Map, down, NewMap)
:- getNextLineSameXInNavMap(Map, NewMap), !.

mapNavigatePushTo(Map, left, NewMap)
:- getPreviousCaseInNavMap(Map, NewMap), !.

mapNavigatePushTo(Map, right, NewMap)
:- getNextCaseInNavMap(Map, NewMap), !.
   


/***********************************************************
** pathFindind_computeMap.pl
***********/



/* ------------------------------------------------
   Calcul l'tat de la map apres mouvement */

   % pathFinding_computeMap(Map, Direction, NewMap, HasMovedMap)


%pathFinding_computeMap(Map, Direction, Map, false).

pathFinding_computeMap(Map, Direction, NewMap, HasMovedMap)
:- pathFinding_preCompute(Map, TempMap),
   getCurrentCasePosInNavMap(Map, Pos),
   pathFinding_computeMinerMod(TempMap, Pos, Direction, TempMap2, TempHasMovedMap),
   mapNavigateTo(TempMap2, [0,0], TempMap3),
   mapNavigateTo(Map,      [0,0], OMap),
   pathFinding_getParentFromDirection(Pos, Direction, OldPos),
   pathFinding_dealCase(OMap, TempMap3, Pos, OldPos, TempHasMovedMap, TempMap4, HasMovedMap),
   mapNavigateTo(TempMap4, Pos, NewMap), !.


/* ------------------------------------------------
   Fait bouger toute la carte */

   % pathFinding_dealCase(OriginMap, Map, MinerPos, HasMovedMapYet, NewMap, HasMovedMap)


% la case est dja traite
pathFinding_dealCase(OriginMap, Map, MinerPos, OldMinerPos, HasMovedMapYet, NewMap, HasMovedMap)
:- getCurrentCaseInNavMap(Map, Case),
   isCaseDealed(Case),
   getNextListCaseInNavMap(Map, TempMap),
   getNextListCaseInNavMap(OriginMap, NewOriginMap),
   pathFinding_dealCase(NewOriginMap, TempMap, MinerPos, OldMinerPos, HasMovedMapYet, NewMap, HasMovedMap), !.
   
   
% la case est un boulet ou diamant avec du vide en dessous
pathFinding_dealCase(OriginMap, Map, MinerPos, OldMinerPos, _, NewMap, HasMovedMap)
:- getCurrentCaseInNavMap(Map, Case),
   ( getCaseType(Case, diam); getCaseType(Case, pierre) ),
   
   % si en dessous ce n'est pas le mineur ou l'ancien mineur
   getCurrentCasePosInNavMap(Map, Pos),
   not(isJustUpper(Pos, MinerPos)),
   not(isJustUpper(Pos, OldMinerPos)),
   
   % il y a du vide en dessous
   getNextLineSameXInNavMap(OriginMap, TempOriginMap),
   getCurrentCaseInNavMap(TempOriginMap, BottomCase),
   getCaseType(BottomCase, vide),
   
   % on rcupre ce qu'il y a reellement sur la case
   getCaseRealType(Case, RealType),
   
   % on met du vide sur cette case et on dit qu'elle est traite
   changeCaseType(Case, 0, NewCase),
   setCaseDealed(NewCase, NewCase2),
   setCurrentCaseInNavMap(Map, NewCase2, TempMap),
   
   % on deplace l'objet case du dessous et on dit que la case est dj modifie
   getNextLineSameXInNavMap(TempMap, TempMap2),
   getCurrentCaseInNavMap(TempMap2, TempBottomCase),
   setCaseDealed(TempBottomCase, TempBottomCase2),
   changeCaseType(TempBottomCase2, RealType, TempBottomCase3),
   setCurrentCaseInNavMap(TempMap2, TempBottomCase3, TempMap3),
   
   % on repasse case du dessus
   getPreviousLineSameXInNavMap(TempMap3, TempMap4),
   
   
   getNextListCaseInNavMap(TempMap4, TempMap5),
   getNextListCaseInNavMap(OriginMap, NewOriginMap),
   pathFinding_dealCase(NewOriginMap, TempMap5, MinerPos, OldMinerPos, true, NewMap, HasMovedMap), !.
   

   
% la case est un boulet ou diamant avec terrain glissant en dessous en dessous
pathFinding_dealCase(OriginMap, Map, MinerPos, OldMinerPos, HasMovedMapYet, NewMap, HasMovedMap)
:- getCurrentCaseInNavMap(Map, Case),
   ( getCaseType(Case, diam); getCaseType(Case, pierre) ),

   % si en dessous ce n'est pas le mineur ou l'ancien mineur
   getCurrentCasePosInNavMap(Map, Pos),
   not(isJustUpper(Pos, MinerPos)),
   not(isJustUpper(Pos, OldMinerPos)),

   % il y a du glissant en dessous
   getNextLineSameXInNavMap(OriginMap, TempOriginMap),
   getCurrentCaseInNavMap(TempOriginMap, BottomCase),
   getCaseRealType(BottomCase, RealType),
   isCaseTypeSlide(RealType),

   % on rcupre ce qu'il y a reellement sur la case
   %getCaseRealType(Case, RealType),
   
   pathFinding_slideCase(OriginMap, Map, MinerPos, OldMinerPos, HasMovedMapYet, NewMap, HasMovedMap), !.
   
   
% on passe simplement  la case suivante
pathFinding_dealCase(OriginMap, Map, MinerPos, OldMinerPos, HasMovedMapYet, NewMap, HasMovedMap)
:- getNextListCaseInNavMap(Map, TempMap),
   getNextListCaseInNavMap(OriginMap, NewOriginMap),
   pathFinding_dealCase(NewOriginMap, TempMap, MinerPos, OldMinerPos, HasMovedMapYet, NewMap, HasMovedMap), !.
   
   
% il n'y a plus de cases
pathFinding_dealCase(_, Map, _, _, HasMovedMap, Map, HasMovedMap) :- !.



/* ------------------------------------------------
   On est sur un terrain glissant */

   % pathFinding_slideCase(OriginMap, Map, MinerPos, OldMinerPos, HasMovedMapYet, NewMap, HasMovedMap)

% la pierre / diamant peut glisser des deux cots
pathFinding_slideCase(OriginMap, Map, MinerPos, OldMinerPos, _, NewMap, HasMovedMap)
:- pathFinding_canSlideLeft(OriginMap, MinerPos, OldMinerPos),
   pathFinding_canSlideRight(OriginMap, MinerPos, OldMinerPos),

   % on rcupre le contenu reel de la case
   getCurrentCaseInNavMap(Map, Case),
   getCaseRealType(Case, RealType),

   % on met du vide
   setCaseDealed(Case, TempCase),
   changeCaseType(TempCase, 0, TempCase2),
   setCurrentCaseInNavMap(Map, TempCase2, TempMap),

   % on va a gauche
   getPreviousCaseInNavMap(TempMap, LeftMap),
   getCurrentCaseInNavMap(LeftMap, LeftCase),

   % on met l'objet
   setCaseDealed(LeftCase, TempLeftCase),
   changeCaseType(TempLeftCase, RealType, TempLeftCase2),
   setCurrentCaseInNavMap(LeftMap, TempLeftCase2, NewLeftMap),

   % on va 2 x  droite
   getNextCaseInNavMap(NewLeftMap, TempMiddle),
   getNextCaseInNavMap(TempMiddle, RightMap),
   getCurrentCaseInNavMap(RightMap, RightCase),

   % on met l'objet
   setCaseDealed(RightCase, TempRightCase),
   changeCaseType(TempRightCase, RealType, TempRightCase2),
   setCurrentCaseInNavMap(RightMap, TempRightCase2, NewRightMap),

   getNextListCaseInNavMap(OriginMap, NewOriginMap),
   pathFinding_dealCase(NewOriginMap, NewRightMap, MinerPos, OldMinerPos, true, NewMap, HasMovedMap), !.



% la pierre / diamant peut glisser seulement  gauche
pathFinding_slideCase(OriginMap, Map, MinerPos, OldMinerPos, _, NewMap, HasMovedMap)
:- pathFinding_canSlideLeft(OriginMap, MinerPos, OldMinerPos),

   % on rcupre le contenu reel de la case
   getCurrentCaseInNavMap(Map, Case),
   getCaseRealType(Case, RealType),

   % on met du vide
   setCaseDealed(Case, TempCase),
   changeCaseType(TempCase, 0, TempCase2),
   setCurrentCaseInNavMap(Map, TempCase2, TempMap),

   % on va a gauche
   getPreviousCaseInNavMap(TempMap, LeftMap),
   getCurrentCaseInNavMap(LeftMap, LeftCase),

   % on met l'objet
   setCaseDealed(LeftCase, TempLeftCase),
   changeCaseType(TempLeftCase, RealType, TempLeftCase2),
   setCurrentCaseInNavMap(LeftMap, TempLeftCase2, NewLeftMap),

   % on va 2 x  droite
   getNextCaseInNavMap(NewLeftMap, TempMiddle),
   getNextCaseInNavMap(TempMiddle, RightMap),

   getNextListCaseInNavMap(OriginMap, NewOriginMap),
   pathFinding_dealCase(NewOriginMap, RightMap, MinerPos, OldMinerPos, true, NewMap, HasMovedMap), !.



% la pierre / diamant peut glisser seulement  droite
pathFinding_slideCase(OriginMap, Map, MinerPos, OldMinerPos, _, NewMap, HasMovedMap)
:- pathFinding_canSlideRight(OriginMap, MinerPos, OldMinerPos),

   % on rcupre le contenu reel de la case
   getCurrentCaseInNavMap(Map, Case),
   getCaseRealType(Case, RealType),

   % on met du vide
   setCaseDealed(Case, TempCase),
   changeCaseType(TempCase, 0, TempCase2),
   setCurrentCaseInNavMap(Map, TempCase2, TempMap),

   % on va  droite
   getNextCaseInNavMap(TempMap, RightMap),
   getCurrentCaseInNavMap(RightMap, RightCase),

   % on met l'objet
   setCaseDealed(RightCase, TempRightCase),
   changeCaseType(TempRightCase, RealType, TempRightCase2),
   setCurrentCaseInNavMap(RightMap, TempRightCase2, NewRightMap),

   getNextListCaseInNavMap(OriginMap, NewOriginMap),
   pathFinding_dealCase(NewOriginMap, NewRightMap, MinerPos, OldMinerPos, true, NewMap, HasMovedMap), !.



% la pierre / diamant ne peut pas glisser
pathFinding_slideCase(OriginMap, Map, MinerPos, OldMinerPos, HasMovedMapYet, NewMap, HasMovedMap)
:- getNextListCaseInNavMap(Map, TempMap),
   getNextListCaseInNavMap(OriginMap, NewOriginMap),
   pathFinding_dealCase(NewOriginMap, TempMap, MinerPos, OldMinerPos, HasMovedMapYet, NewMap, HasMovedMap), !.
   
   



/* ------------------------------------------------
   On peut glisser a droite ou a gauche */

   % pathFinding_canSlideLeft(OriginMap, MinerPos, OldMinerPos)
   % pathFinding_canSlideRight(OriginMap, MinerPos, OldMinerPos)


pathFinding_canSlideLeft(OriginMap, MinerPos, OldMinerPos)
:- % on va a gauche
   getPreviousCaseInNavMap(OriginMap, LeftOriginMap),

   % le mineur n'est pas a gauche
   getCurrentCasePosInNavMap(LeftOriginMap, Pos),
   Pos \= MinerPos,
   Pos \= OldMinerPos,

   % il y a du vide a gauche
   getCurrentCaseInNavMap(LeftOriginMap, LeftCase),
   getCaseType(LeftCase, vide),

   % on va en bas a gauche
   getNextLineSameXInNavMap(LeftOriginMap, LeftBottomOriginMap),

   % le mineur n'est pas en bas a gauche
   getCurrentCasePosInNavMap(LeftBottomOriginMap, Pos2),
   Pos2 \= MinerPos,
   Pos2 \= OldMinerPos,

   % il y a du vide en bas  droite
   getCurrentCaseInNavMap(LeftBottomOriginMap, LeftBottomCase),
   getCaseType(LeftBottomCase, vide), !.



pathFinding_canSlideRight(OriginMap, MinerPos, OldMinerPos)
:- % on va a droite
   getNextCaseInNavMap(OriginMap, RightOriginMap),

   % le mineur n'est pas a droite
   getCurrentCasePosInNavMap(RightOriginMap, Pos),
   Pos \= MinerPos,
   Pos \= OldMinerPos,

   % il y a du vide a droite
   getCurrentCaseInNavMap(RightOriginMap, RightCase),
   getCaseType(RightCase, vide),

   % on va en bas a droite
   getNextLineSameXInNavMap(RightOriginMap, RightBottomOriginMap),

   % le mineur n'est pas en bas a droite
   getCurrentCasePosInNavMap(RightBottomOriginMap, Pos2),
   Pos2 \= MinerPos,
   Pos2 \= OldMinerPos,

   % il y a du vide en bas  droite
   getCurrentCaseInNavMap(RightBottomOriginMap, RightBottomCase),
   getCaseType(RightBottomCase, vide), !.
   




/* ------------------------------------------------
   Fait bouger le mineur et modifie l'environement directement modifi ( pousser les blocs ) */
   
   % pathFinding_computeMinerMod(Map, Pos, Direction, NewMap, HasMovedMap)

   
% on dplace une pierre
pathFinding_computeMinerMod(Map, Pos, Direction, NewMap, true)
:- mapNavigateTo(Map, Pos, TempMap),
   getCurrentCaseInNavMap(TempMap, Case),
   getCaseType(Case, pierre),
   getCaseRealType(Case, CaseType),
   changeCaseType(Case, 0, NewCase),      % on met du vide
   setCurrentCaseInNavMap(TempMap, NewCase, TempMap2),
   mapNavigatePushTo(TempMap2, Direction, TempMap3),
   pathFinding_computeMinerMod_push(TempMap3, Direction, CaseType, NewMap), !.
   
   
% si on ne pouse rien, le mineur ne dplace pas l'environement
pathFinding_computeMinerMod(Map, _, _, Map, false) :- !.



/* ------------------------------------------------
   Dplace un bloc de pierres */

   % pathFinding_computeMinerMod_push(Map, Direction, CaseType, NewMap)

% il y a du vide, on a fini de dplacer
pathFinding_computeMinerMod_push(Map, _, CaseType, NewMap)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, vide),
   changeCaseType(Case, CaseType, NewCase),
   setCaseDealed(NewCase, NewCase2),
   setCurrentCaseInNavMap(Map, NewCase2, NewMap), !.
   
   
% ce n'est pas du vide on le dplace
pathFinding_computeMinerMod_push(Map, Direction, CaseType, NewMap)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseRealType(Case, HereType),
   changeCaseType(Case, CaseType, NewCase),
   setCaseDealed(NewCase, NewCase2),
   setCurrentCaseInNavMap(Map, NewCase2, TempMap),
   mapNavigatePushTo(TempMap, Direction, TempMap2),
   pathFinding_computeMinerMod_push(TempMap2, Direction, HereType, NewMap), !.
   


/* ------------------------------------------------
   Tager chaque case de la carte comme non traite */

   % pathFinding_preCompute(Map, NewMap)

pathFinding_preCompute(Map, NewMap)
:- getCurrentCasePosInNavMap(Map, Pos),
   mapNavigateTo(Map, [0, 0], TempMap),
   pathFinding_preCompute_(TempMap, TempMap2),
   mapNavigateTo(TempMap2, Pos, NewMap), !.
   
   
   % pathFinding_preCompute_(Map, NewMap)
   
% On traite la case
pathFinding_preCompute_(Map, NewMap)
:- getCurrentCaseInNavMap(Map, Case),
   setCaseUnDealed(Case, NewCase),
   setCurrentCaseInNavMap(Map, NewCase, TempMap),
   pathFinding_preComputeNextCase(TempMap, NewMap), !.
   

% Il y a une case suivante, on y va
pathFinding_preComputeNextCase(Map, NewMap)
:- getNextListCaseInNavMap(Map, TempMap),
   pathFinding_preCompute_(TempMap, NewMap), !.
   
% Il n'y a pas de case suivante, on termine
pathFinding_preComputeNextCase(Map, Map).
   


/***********************************************************
** pathFinding.pl
***********/


maximumWeightSpace(0).
minimumWeightSpace(2).
maximumRockPushable(8).
majorForRockClimbing(4).
majorForAlreadyExisting(1000).
   
/* ------------------------------------------------
   Find a way  */
   
   % Basic path finding call
   % pathFinding(StartMap, Destination, Way)
   
   % Full path finding call
   % pathFinding(StartMap, Destination, Way, CanGoToNearTarget, MustBeAbleToLeave)
   
   % CanGoToNearTarget means we go to the first target we found (true or false)
   
   
% Basic path finding call
pathFinding(StartMap, Destination, Way)
:- pathFinding(StartMap, Destination, Way, true, true).
   
% Full path finding call
pathFinding(StartMap, Destination, Way, CanGoToNearTarget, MustBeAbleToLeave)
:- recorded(mapHasMoved, MapIsMoving),
   pathFinding(StartMap, MapIsMoving, Destination, Way, CanGoToNearTarget, MustBeAbleToLeave), !.
   
   
% Full path finding call
pathFinding(StartMap, MapIsMoving, Destination, Way, CanGoToNearTarget, MustBeAbleToLeave)
:- pathfinding_createCloseList(StartMap, MapIsMoving, Destination, CloseList),
   pathFinding([Destination, [], CloseList, [], 1, 1, CanGoToNearTarget, MustBeAbleToLeave, [], []], Info),
   pathFinding_getWay(Info, Way), !.



/* ------------------------------------------------
   Real path finding call */

% pathFinding(PathFindingInfos)

% PathFindingInfos : [Destination, OpenList, CloseList, WaitList, LastCaseId, LastMapId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Way]


% on arrive a la destination
pathFinding(Info, NewInfo)
:- pathFinding_getDestination(Info, Destination),
   pathFinding_getCloseList(Info, CloseList),
   pathFinding_getLastAddedMap(CloseList, Map),
   getCurrentCasePosInNavMap(Map, Destination),
   pathFinding_getLastAddedId(CloseList, DestinationId),
   pathFinding_computeWay(CloseList, DestinationId, Way),
   pathFinding_changeWay(Info, Way, NewInfo), !.
   
   
% boucle principale de pathfinding
pathFinding(Info, NewInfo)
:- debugN_pf('=== main PF loop ==='),
   pathFinding_addAdjacentCasesToOpenList(Info, Info2),
   debugN_pf('** adjacent added **'),
   pathFinding_dealBreakPoint_and_moveBestCaseFromOpenToCloseList(Info2, NewInfo), !.
   
   
/* ------------------------------------------------
   WHILE opration of main pathfinding loop */

   % pathFinding_dealBreakPoint_and_moveBestCaseFromOpenToCloseList(Info)

% BreakPoint and CanGoToNearTarget are true : we found an other target, just go there
pathFinding_dealBreakPoint_and_moveBestCaseFromOpenToCloseList(Info, NewInfo)
:- pathFinding_getCanGoToNearTarget(Info, true),
   pathFinding_getBreakPoint(Info, NewDestPos),
   isPosition(NewDestPos),
   
   debugN_pf('==== breakPoint ============================================'),
   
   pathFinding_getCloseList(Info, CloseList),
   pathFinding_getLastAddedId(CloseList, ParentId),
   
   debugN_pf('parent id'),
   
   pathFinding_getLastAddedMap(CloseList, Map),
   mapNavigateTo(Map, NewDestPos, NewMap),
   
   pathFinding_getLastCaseId(Info, LastId),
   NewId is LastId + 1,

   % ||||||||||||||||||||||||||||||||||||||||||||||||||||||
   % ||||||||||||||||||||||||||||||||||||||||||||||||||||||
   % ||||||||||||||||||||||||||||||||||||||||||||||||||||||
   % TODO MapIsMoving true or false
   

   pathFinding_addCaseInCloseList(CloseList, ParentId, NewId, NewMap, false, NewCloseList),
   
   pathFinding_computeWay(NewCloseList, NewId, Way),
   debug_pf('way found : '),
   debugN_pf(Way),
   
   pathFinding_changeWay(Info, Way, NewInfo),
   
   debug_pf('way : '),
   debugN_pf(Way), !.


% There is no breakpoint, add the best case from open to close list
pathFinding_dealBreakPoint_and_moveBestCaseFromOpenToCloseList(Info, NewInfo)
:- pathFinding_moveBestCaseFromOpenToCloseList(Info, Info2),
   pathFinding(Info2, NewInfo), !.
   


/* ------------------------------------------------
   A a case from open to close list */

   % pathFinding_moveBestCaseFromOpenToCloseList(OpenList, CloseList, NewOpenList, NewCloseList)

%pathFinding_moveBestCaseFromOpenToCloseList([ [ _ , Element ] | RestOpenList], CloseList, RestOpenList, [ Element | CloseList ] )
%:- debugN_pf('in pathFinding_moveBestCaseFromOpenToCloseList'), !.

pathFinding_moveBestCaseFromOpenToCloseList(Info, NewInfo)
:- pathFinding_getOpenList(Info, [ [ W , Element ] | RestOpenList]),
   pathFinding_getCloseList(Info, CloseList),
   
   pathFinding_changeOpenAndCloseLists(Info, RestOpenList, [ Element | CloseList ], NewInfo),
   
   % for tracing :
   pathFinding_getLastAddedMap([ Element | CloseList ], Map),
   getCurrentCasePosInNavMap(Map, Pos),
   debug_pf(' ///////////// case added : '),
   debug_pf(Pos),
   debug_pf('poid :'),
   debugN_pf(W), !.
   
   
pathFinding_moveBestCaseFromOpenToCloseList(Info, NewInfo)
:- pathFinding_getWaitList(Info, [ [ W , Element ] | RestWaitList]),
   debug_pf('Open List is empty, but there are'),
   getListSize(RestWaitList, NB),
   debug_pf(NB),
   debugN_pf('elements in Wait list'),

   pathFinding_getCloseList(Info, CloseList),

   pathFinding_changeWaitAndCloseLists(Info, RestWaitList, [ Element | CloseList ], NewInfo),

   % for tracing :
   pathFinding_getLastAddedMap([ Element | CloseList ], Map),
   getCurrentCasePosInNavMap(Map, Pos),
   debug_pf(' ///////////// case added : '),
   debug_pf(Pos),
   debug_pf('poid :'),
   debugN_pf(W), !.



/* ------------------------------------------------
   Rcuprer un chemin  partir d'une liste ferme  */

   % pathFinding_computeWay(CloseList, Destination, Way)

pathFinding_computeWay(CloseList, Destination, Way)
:- debug_pf('cherche comment arriver  :'),
   debugN_pf(Destination),
   %debugN_pf(CloseList),
   pathFinding_computeWay(CloseList, CloseList, Destination, [], Way), !.


% pathFinding_computeWay(CloseList, CloseList, Searched, CurrentWay, Way)

%[0, Dist, [-1, -1], NewNavMap]

% on est sur la case recherche et c'est la premiere case du chemin
pathFinding_computeWay(_, [ [_, _, 0, 1, _, _, Map | _] | _ ], 1, CurrentWay, [ Pos | CurrentWay ])
:- getCurrentCasePosInNavMap(Map, Pos), !.

% on est sur la case recherche
pathFinding_computeWay(CloseList, [ [_, _, Parent, Searched, _, _, Map | _] | _ ], Searched, CurrentWay, Way)
:- getCurrentCasePosInNavMap(Map, Pos),
   debug_pf('%% bonne case : '),
   debug_pf(Searched),
   debug_pf('parent :'),
   debugN_pf(Parent),
   pathFinding_computeWay(CloseList, CloseList, Parent, [ Pos | CurrentWay], Way), !.


% on n'est pas sur la case recherche
pathFinding_computeWay(CloseList, [ [_, _, _, Id | _] | Rest ], Searched, CurrentWay, Way)
:- debug_pf('mauvaise case : '),
   debugN_pf(Id),
   pathFinding_computeWay(CloseList, Rest, Searched, CurrentWay, Way), !.





/* ------------------------------------------------
   Calcul si la case ajoute devrait tre un breakpoint (diament ou cible permettant d'arreter la recherche de chemin) */

   % pathFinding_isBreakPoint(Map, CanGoToNearTarget, BreakPoint)


% la case est une cible
pathFinding_isBreakPoint(Map, true, BreakPoint)
:- getCurrentCaseInNavMap(Map, Case),
   caseIsTarget(Case),
   getCurrentCasePosInNavMap(Map, BreakPoint), !.


% la case n'est pas une cible ... pas de breakpoint
pathFinding_isBreakPoint(_, _, []) :- !.



/* ------------------------------------------------
   Rcuprer les coordonnes de la case parent */

   % pathFinding_getParentFromDirection(Pos, Direction, Parent)

pathFinding_getParentFromDirection([X, Y], up, [X, NewY])
:- NewY is Y + 1, !.

pathFinding_getParentFromDirection([X, Y], down, [X, NewY])
:- NewY is Y - 1, !.

pathFinding_getParentFromDirection([X, Y], left, [NewX, Y])
:- NewX is X + 1, !.

pathFinding_getParentFromDirection([X, Y], right, [NewX, Y])
:- NewX is X - 1, !.

pathFinding_getParentFromDirection([X, Y], here, [X, Y]) :- !.


/* ------------------------------------------------
   Calcul si on peut sortir de cette situation */

   % pathFinding_isAbleToLeave(Map, HasMovedMap, MustBeAbleToLeave)


% Si la carte n'a pas bouge, c'est bon
pathFinding_isAbleToLeave(_, false, _) :- !.


% si on a pas besoin de sortir, c'est bon
pathFinding_isAbleToLeave(_, _, false) :- !.


% sinon on cherche un chemin pr sortir
pathFinding_isAbleToLeave(Map, _, _)
:- getExitPos(Map, Destination),
   pathFinding(Map, Destination, _, false, false).


%.............. TODO ................
% creer le prdicat getExitPos(Map, Destination)



/* ------------------------------------------------
   Rcupre le premier break point disponible  */

   % pathFinding_dealBreakPoint(BreakPoint_1, BreakPoint_2, BreakPoint_3, BreakPoint_4, BreakPoint)

% Il n'y a pas de breakpoint
pathFinding_dealBreakPoint([], [], [], [], []) :- !.

% Il y a un breakpoint ... le renvoyer
pathFinding_dealBreakPoint([X,Y], _, _, _, [X,Y]) :- !.
pathFinding_dealBreakPoint(_, [X,Y], _, _, [X,Y]) :- !.
pathFinding_dealBreakPoint(_, _, [X,Y], _, [X,Y]) :- !.
pathFinding_dealBreakPoint(_, _, _, [X,Y], [X,Y]) :- !.


% Il n'y a pas de breakpoint
pathFinding_dealBreakPoint([], [], [], [], [], []) :- !.

% Il y a un breakpoint ... le renvoyer
pathFinding_dealBreakPoint([X,Y], _, _, _, _, [X,Y]) :- !.
pathFinding_dealBreakPoint(_, [X,Y], _, _, _, [X,Y]) :- !.
pathFinding_dealBreakPoint(_, _, [X,Y], _, _, [X,Y]) :- !.
pathFinding_dealBreakPoint(_, _, _, [X,Y], _, [X,Y]) :- !.
pathFinding_dealBreakPoint(_, _, _, _, [X,Y], [X,Y]) :- !.


/***********************************************************
** pathFinding_addCase.pl
***********/


/* ------------------------------------------------
   Ajoute les cases adjacentes  la derniere case ajoute a la Close List  la Open List */

   % pathFinding_addAdjacentCasesToOpenList(Info, NewInfo)

pathFinding_addAdjacentCasesToOpenList(Info, NewInfo)
:- pathFinding_getCloseList(Info, CloseList),
   pathFinding_getLastAddedMap(CloseList, Map),
   pathFinding_getLastAddedId(CloseList, ParentId),

   pathFinding_changeBreakPoint(Info, [], Info1),
   
   %mapNavigateTo(Map, PosMineur, TempMap1),
   getCurrentCaseInNavMap(Map, Case),
   changeCaseType(Case, 1, NewCase),
   setCurrentCaseInNavMap(Map, NewCase, TempMap),

   pathFinding_addTopCase(TempMap, ParentId, Info1, Info2),
   pathFinding_addLeftCase(TempMap, ParentId, Info2, Info3),
   pathFinding_addRightCase(TempMap, ParentId, Info3, Info4),
   pathFinding_addBottomCase(TempMap, ParentId, Info4, Info5),
   
   pathFinding_addCurrentCase(TempMap, ParentId, Info5, Info6),
   

   pathFinding_getBreakPoint(Info2, BreakPoint_1),
   pathFinding_getBreakPoint(Info3, BreakPoint_2),
   pathFinding_getBreakPoint(Info4, BreakPoint_3),
   pathFinding_getBreakPoint(Info5, BreakPoint_4),
   pathFinding_getBreakPoint(Info6, BreakPoint_5),

   pathFinding_dealBreakPoint(BreakPoint_1, BreakPoint_2, BreakPoint_3, BreakPoint_4, BreakPoint_5, BreakPoint),

   pathFinding_changeBreakPoint(Info6, BreakPoint, NewInfo), !.



/* ------------------------------------------------
   Essai d'ajouter la case  la liste ouverte */

   % pathFinding_tryAddCase(Map, ParentId, Destination, OpenList , CloseList, LastId, NewOpenList, NewLastId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Direction)

% on ne peut pas marcher sur ce type de terrain
pathFinding_tryAddCase(Map, _, _, Info, Info)
:- getCurrentCaseInNavMap(Map, Case),
   debug_pf('try to add :'),
   getCurrentCasePosInNavMap(Map, Pos),
   debug_pf(Pos),
   getCaseType(Case, Type),
   debug_pf(Type),
   notWalkableType(Type),
   debugN_pf('impossible to go here'), !.    % C'est un no_way ou un monstre


% cette case n'est pas scurise (monstre a proximite, boulet au dessus)
%pathFinding_tryAddCase(Map, _, _, OpenList , _, LastId, OpenList, LastId, _, _, [], _)
pathFinding_tryAddCase(Map, _, _, Info, Info)
:- notSafeCase(Map),
   debugN_pf('not safe'), !.


% grer si la case est un boulet ( pousser )
%pathFinding_tryAddCase(Map, ParentId, Destination, OpenList, CloseList, LastId, NewOpenList, NewLastId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Direction)
pathFinding_tryAddCase(Map, ParentId, Direction, Info, NewInfo)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, pierre),
   debugN_pf('yes pierre'),
   pathFinding_tryAddCaseRock(Map, ParentId, Direction, Info, NewInfo),
   debugN_pf('can go on this rock'), !.


% rien n'empeche l'ajout de la case
%pathFinding_tryAddCase(Map, ParentId, Destination, OpenList, CloseList, LastId, NewOpenList, NewLastId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Direction)
pathFinding_tryAddCase(Map, ParentId, Direction, Info, NewInfo)
:- getCurrentCaseInNavMap(Map, Case),
   not(getCaseType(Case, pierre)),
   debugN_pf('YES ADDED'),
   pathFinding_addCase(Map, ParentId, Direction, Info, NewInfo), !.

% dernier cas : on n'ajoute pas la case
pathFinding_tryAddCase(_, _, _, Info, Info)
:- debugN_pf('can''t move rock'), !.


/* ------------------------------------------------
   Ajoute la case  la Open List */

   % pathFinding_addCase(Map, ParentId, Destination, OpenList , CloseList, LastId, NewOpenList, NewLastId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Direction, Majoration)


pathFinding_addCase(Map, ParentId, Direction, Info, NewInfo)
:- pathFinding_addCase(Map, ParentId, Direction, 0, Info, NewInfo), !.


%pathFinding_addCase(Map, ParentId, Destination, OpenList, CloseList, LastId, NewOpenList, NewLastId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Direction, Maj)
pathFinding_addCase(Map, ParentId, Direction, Maj, Info, NewInfo)
:- getCurrentCasePosInNavMap(Map, Pos),                                           % rcupre la position
   pathFinding_getDestination(Info, Destination),
   getDist(Pos, Destination, FlyDist),                                            % rcupre la distance entre la destination et la nouvelle position ( vol d'oiseau )
   pathFinding_getCloseList(Info, CloseList),
   pathFinding_getOpenList(Info, OpenList),
   pathFinding_getDistLastAddedMap(CloseList, Dist),                              % rcupre la distance au dpart de la case prcdente
   NewDist is (Dist + 1 + Maj),
   Weight is (NewDist + FlyDist * 2),                                             % calcul le poid ( somme des distances + majoration )

   not(pathFinding_existInCloseList(Pos, Weight, CloseList)),                     % la case n'est pas prsente dans les 2 listes avec des coefficients trop bas
   not(pathFinding_existInOpenList(Pos, Weight, OpenList)),
   
   %pathFinding_addInChosenList(Map, ParentId, Direction, Weight, NewDist, FlyDist, Info, NewInfo),

   %pathFinding_deleteInOpenList(Pos, Weight, OpenList, TempOpenList),

   pathFinding_getMustBeAbleToLeave(Info, MustBeAbleToLeave),
   
   
   getCurrentCasePosInNavMap(Map, Pos),
   pathFinding_getParentFromDirection(Pos, Direction, ParentPos),
   mapNavigateTo(Map, ParentPos, TempMap),
   getCurrentCaseInNavMap(TempMap, Case),
   changeCaseType(Case, 0, NewCase),
   setCurrentCaseInNavMap(TempMap, NewCase, TempMap2),
   mapNavigateTo(TempMap2, Pos, TempMap3),
   
   

   pathFinding_doWeComputeMap(TempMap3, Direction, CloseList, NewMap, HasMovedMap),
   
   /*(
     (
       not(pathFinding_existInCloseList(Pos, Weight, CloseList)),
       not(pathFinding_existInOpenList(Pos, Weight, OpenList)),
       NewDist2 is NewDist
     )
     ;
     (
       HasMovedMap = true,
       NewDist2 is NewDist + 10
     )
   ),      */

   %pathFinding_computeMap(Map, Direction, NewMap, HasMovedMap),                   % on calcule la nouvelle carte gnre par le dplacement, HasMovedMap true si la carte est en mouvement
   %pathFinding_isAbleToLeave(NewMap, HasMovedMap, MustBeAbleToLeave),             % on teste si le nouveau mouvement nous permet toujours de sortir

   pathFinding_getLastCaseId(Info, LastId),
   pathFinding_getLasMapId(Info, LastMapId),

   NewLastId is LastId + 1,                                                       % gnration de l'id
   debug_pf('on ajoute la case'), debug_pf('id :'), debug_pf(NewLastId),
   debug_pf('parent :'), debugN_pf(ParentId),

   % format : [ StartDist, FlyDist, ParentId, CaseId, MapId, MapFrame, Map, HasMovedMap ]

   addInAscOrderedList([ Weight , [ NewDist, FlyDist, ParentId, NewLastId, LastMapId, 0, NewMap, HasMovedMap ] ], OpenList, NewOpenList),  % ajoute la case  la liste ouverte

   pathFinding_getCanGoToNearTarget(Info, CanGoToNearTarget),

   pathFinding_isBreakPoint(Map, CanGoToNearTarget, BreakPoint),                  % test si la case ajoute doit retourner un breakpoint

   pathFinding_changeBreakPoint(Info, BreakPoint, Info2),
   pathFinding_changeOpenList(Info2, NewOpenList, Info3),
   pathFinding_changeLastCaseId(Info3, NewLastId, NewInfo), !.
   
   
   
      /*

% Ajoute la case  la wait list
pathFinding_addCase(Map, ParentId, Direction, Maj, Info, NewInfo)
:- getCurrentCasePosInNavMap(Map, Pos),                                           % rcupre la position
   pathFinding_getDestination(Info, Destination),
   getDist(Pos, Destination, FlyDist),                                            % rcupre la distance entre la destination et la nouvelle position ( vol d'oiseau )
   pathFinding_getWaitList(Info, WaitList),
   %pathFinding_getOpenList(Info, OpenList),
   pathFinding_getCloseList(Info, CloseList),
   pathFinding_getDistLastAddedMap(CloseList, Dist),                              % rcupre la distance au dpart de la case prcdente
   majorForAlreadyExisting(Maj2),
   NewDist is (Dist + 1 + Maj + Maj2),
   Weight is (NewDist + FlyDist * 2),                                             % calcul le poid ( somme des distances + majoration )

   %pathFinding_getMustBeAbleToLeave(Info, MustBeAbleToLeave),

   %pathFinding_computeMap(Map, Direction, NewMap, HasMovedMap),                   % on calcule la nouvelle carte gnre par le dplacement, HasMovedMap true si la carte est en mouvement
   %pathFinding_isAbleToLeave(NewMap, HasMovedMap, MustBeAbleToLeave),             % on teste si le nouveau mouvement nous permet toujours de sortir
   
   pathFinding_getMustBeAbleToLeave(Info, MustBeAbleToLeave),
   pathFinding_doWeComputeMap(Map, Direction, CloseList, NewMap, HasMovedMap),

   pathFinding_getLastCaseId(Info, LastId),
   pathFinding_getLasMapId(Info, LastMapId),

   NewLastId is LastId + 1,                                                       % gnration de l'id
   debug_pf('on ajoute la case dans waiting list'), debug_pf('id :'), debug_pf(NewLastId),
   debug_pf('parent :'), debugN_pf(ParentId),

   % format : [ StartDist, FlyDist, ParentId, CaseId, MapId, MapFrame, Map ]
   
      % ||||||||||||||||||||||||||||||||||||||||||||||||||||||
   % ||||||||||||||||||||||||||||||||||||||||||||||||||||||
   % ||||||||||||||||||||||||||||||||||||||||||||||||||||||
   % TODO MapIsMoving true or false

   addInAscOrderedList([ Weight , [ NewDist, FlyDist, ParentId, NewLastId, LastMapId, 0, NewMap, HasMovedMap ] ], WaitList, NewWaitList),  % ajoute la case  la liste ouverte

   %pathFinding_getCanGoToNearTarget(Info, CanGoToNearTarget),

   %pathFinding_isBreakPoint(Map, CanGoToNearTarget, BreakPoint),                  % test si la case ajoute doit retourner un breakpoint

   %pathFinding_changeBreakPoint(Info, BreakPoint, Info2),
   pathFinding_changeWaitList(Info, NewWaitList, Info2),
   pathFinding_changeLastCaseId(Info2, NewLastId, NewInfo), !.
                                                         */

% on ne peut pas ajouter la case  la liste ouverte
%pathFinding_addCase(_, _, _, OpenList, _, LastId, OpenList, LastId, _, _, [], _, _) :- !.
pathFinding_addCase(_, _, _, _, Info, Info) :- !.




/* ------------------------------------------------
   Recalcule la map ou pas celon s'il y a des changements a effectuer ou pas */

   % pathFinding_doWeComputeMap(Map, Direction, CloseList, NewMap, HasMovedMap)

% Si on vient d'une case qui bouge
pathFinding_doWeComputeMap(Map, Direction, CloseList, NewMap, HasMovedMap)
:- pathFinding_getLastAddedHasMoved(CloseList, true),           % la derniere case bougait
   debugN_mm('recompute 1 !'),
   pathFinding_computeMap(Map, Direction, NewMap, HasMovedMap),
   debug_mm('HasMovedMap : '),
   debugN_mm(HasMovedMap), !.  % on calcule la nouvelle carte gnre par le dplacement, HasMovedMap true si la carte est en mouvement

% Si atteri sur un diamant ou pierre
pathFinding_doWeComputeMap(Map, Direction, _, NewMap, HasMovedMap)
:- getCurrentCaseInNavMap(Map, Case),
   (getCaseType(Case, diam) ; getCaseType(Case, pierre)),
   debugN_mm('recompute 2 !'),
   pathFinding_computeMap(Map, Direction, NewMap, HasMovedMap), !.  % on calcule la nouvelle carte gnre par le dplacement, HasMovedMap true si la carte est en mouvement

% Si on libre du vide et que ce vide permet un dplacement
pathFinding_doWeComputeMap(Map, Direction, _, NewMap, HasMovedMap)
:- getCurrentCasePosInNavMap(Map, Pos),
   pathFinding_getParentFromDirection(Pos, Direction, OldPos),
   mapNavigateTo(Map, OldPos, OldPosMap),
   doesCaseCanMakeMoves(OldPosMap, Pos),
   debugN_mm('recompute 3 !'),
   pathFinding_computeMap(Map, Direction, NewMap, HasMovedMap), !.  % on calcule la nouvelle carte gnre par le dplacement, HasMovedMap true si la carte est en mouvement

% Si la carte ne bouge pas
pathFinding_doWeComputeMap(Map, _, _, Map, false) :- debugN_mm('no compute ...'), !.




/* ------------------------------------------------
   La libration de la case Map permet t'elle de mettre en mouvement la carte ?
   Pos est la nouvelle position du mineur */

   % doesCaseCanMakeMoves(Map, Pos)


% il y a une pierre ou un diamant au dessus
doesCaseCanMakeMoves(Map, _)
:- getPreviousLineSameXInNavMap(Map, NewMap),
   getCurrentCaseInNavMap(NewMap, Case),
   (getCaseType(Case, diam) ; getCaseType(Case, pierre)), !.


% il y a du vide au dessus avec un objet glissant  gauche ou a droite
doesCaseCanMakeMoves(Map, Pos)
:- getPreviousLineSameXInNavMap(Map, NewMap),
   getCurrentCasePosInNavMap(NewMap, UpPos),

   UpPos \= Pos,                                % il n'y a pas le mineur

   ((
      getPreviousCaseInNavMap(NewMap, TempMap1),
      getCurrentCaseInNavMap(TempMap1, Case1),
      (getCaseType(Case1, diam) ; getCaseType(Case1, pierre)), % la case  est pierre ou diamant
      getNextLineSameXInNavMap(TempMap1, TempMap1_2),          % on va en dessous
      getCurrentCaseInNavMap(TempMap1_2, Case1_2),             % on rcupre la case
      getCaseRealType(Case1_2, Case1_2_Type),                  % on rcupre le type de la case
      isCaseTypeSlide(Case1_2_Type)                            % ca glisse
   );(
      getNextCaseInNavMap(NewMap, TempMap2),
      getCurrentCaseInNavMap(TempMap2, Case2),
      (getCaseType(Case2, diam) ; getCaseType(Case2, pierre)), % la case  est pierre ou diamant
      getNextLineSameXInNavMap(TempMap2, TempMap2_2),          % on va en dessous
      getCurrentCaseInNavMap(TempMap2_2, Case2_2),             % on rcupre la case
      getCaseRealType(Case2_2, Case2_2_Type),                  % on rcupre le type de la case
      isCaseTypeSlide(Case2_2_Type)                            % ca glisse
   )), !.


% il y a un objet glissant  gauche ou a droite
doesCaseCanMakeMoves(Map, _)
:- ((
      getPreviousCaseInNavMap(Map, TempMap1),
      getCurrentCaseInNavMap(TempMap1, Case1),
      (getCaseType(Case1, diam) ; getCaseType(Case1, pierre)), % la case  est pierre ou diamant
      getNextLineSameXInNavMap(TempMap1, TempMap1_2),          % on va en dessous
      getCurrentCaseInNavMap(TempMap1_2, Case1_2),             % on rcupre la case
      getCaseRealType(Case1_2, Case1_2_Type),                  % on rcupre le type de la case
      isCaseTypeSlide(Case1_2_Type)                            % ca glisse
   );(
      getNextCaseInNavMap(Map, TempMap2),
      getCurrentCaseInNavMap(TempMap2, Case2),
      (getCaseType(Case2, diam) ; getCaseType(Case2, pierre)), % la case  est pierre ou diamant
      getNextLineSameXInNavMap(TempMap2, TempMap2_2),          % on va en dessous
      getCurrentCaseInNavMap(TempMap2_2, Case2_2),             % on rcupre la case
      getCaseRealType(Case2_2, Case2_2_Type),                  % on rcupre le type de la case
      isCaseTypeSlide(Case2_2_Type)                            % ca glisse
   )), !.
   
   
   

/* ------------------------------------------------
   Ajoute la case pierre  la Open List */

   % pathFinding_tryAddCaseRock(Map, ParentId, Destination, OpenList, CloseList, LastId, NewOpenList, NewLastId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Direction)
   % pathFinding_tryAddCaseRock(Map, ParentId, Direction, Info, NewInfo)

%pathFinding_tryAddCaseRock(Map, ParentId, Destination, OpenList, CloseList, LastId, NewOpenList, NewLastId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Direction)
pathFinding_tryAddCaseRock(Map, ParentId, Direction, Info, NewInfo)
:- maximumRockPushable(NB),
   debug_pf('NB geted'),
   pathFinding_canWalkInThisRockDirection(Map, Map, ParentId, Direction, NB, Info, NewInfo), !.
   
   
% On ne peut pas pousser vers le bas
pathFinding_canWalkInThisRockDirection(_, _, down, _, _, Info, Info) :- !.


% C'est le vide, on peut pousser par la
%pathFinding_canWalkInThisRockDirection(Map, MovingMap, ParentId, Destination, OpenList, CloseList, LastId, NewOpenList, NewLastId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Direction, NB)
pathFinding_canWalkInThisRockDirection(Map, MovingMap, ParentId, Direction, NB, Info, NewInfo)
:- NB > 0,
   mapNavigatePushTo(MovingMap, Direction, NewMap),
   getCurrentCaseInNavMap(NewMap, Case),
   getCaseType(Case, vide),
   majorForRockClimbing(Major),
   pathFinding_addCase(Map, ParentId, Direction, Major, Info, NewInfo), !.


% la case est un boulet ou un diamant, on continue de voir si on peut pousser
%pathFinding_canWalkInThisRockDirection(Map, MovingMap, ParentId, Destination, OpenList, CloseList, LastId, NewOpenList, NewLastId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Direction, NB)
pathFinding_canWalkInThisRockDirection(Map, MovingMap, ParentId, Direction, NB, Info, NewInfo)
:- NB > 0,
   mapNavigatePushTo(MovingMap, Direction, NewMap),
   getCurrentCaseInNavMap(NewMap, Case),
   ( getCaseType(Case, pierre) ; getCaseType(Case, diam) ),
   
   % il ne doit pas y avoir de vide en dessous
   mapNavigatePushTo(NewMap, down, TempMap),
   getCurrentCaseInNavMap(TempMap, TempCase),
   %not(getCaseType(TempCase, vide)),
   
   NewNB is NB - 1,
   pathFinding_canWalkInThisRockDirection(Map, NewMap, ParentId, Direction, NewNB, Info, NewInfo), !.


% Ce n'est pas le vide, on ne peut pas marcher ici
%pathFinding_canWalkInThisRockDirection(_, _, _, OpenList , _, LastId, OpenList, LastId, _, _, _, _, _) :- !.
pathFinding_canWalkInThisRockDirection(_, _, _, _, _, Info, Info) :- !.



/* ------------------------------------------------
   Ajoute la case du haut  la Open List */

   % pathFinding_addTopCase(Map, ParentId, Destination, OpenList, CloseList, LastId, NewOpenList, NewLastId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint)


%pathFinding_addTopCase(Map, ParentId, Destination, OpenList , CloseList, LastId, NewOpenList, NewLastId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint)
pathFinding_addTopCase(Map, ParentId, Info, NewInfo)
:- getCurrentCasePosInNavMap(Map, [X, Y]),     % on rcup la position
   NewY is Y - 1,                              % on dcrmente Y (vers le haut)
   mapNavigateTo(Map, [X, NewY], NewMap),      % on se dplace vers le haut
   pathFinding_tryAddCase(NewMap, ParentId, up, Info, NewInfo), !.


/* ------------------------------------------------
   Ajoute la case de gauche  la Open List */

   % pathFinding_addLeftCase(Map, ParentId, Destination, OpenList, CloseList, LastId, NewOpenList, NewLastId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint)


%pathFinding_addLeftCase(Map, ParentId, Destination, OpenList, CloseList, LastId, NewOpenList, NewLastId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint)
pathFinding_addLeftCase(Map, ParentId, Info, NewInfo)
:- getCurrentCasePosInNavMap(Map, [X, Y]),     % on rcup la position
   NewX is X - 1,                              % on dcrmente X (vers la gauche)
   mapNavigateTo(Map, [NewX, Y], NewMap),      % on se dplace vers la gauche
   pathFinding_tryAddCase(NewMap, ParentId, left, Info, NewInfo), !.


/* ------------------------------------------------
   Ajoute la case de droite  la Open List */

   % pathFinding_addRightCase(Map, ParentId, Destination, OpenList, CloseList, LastId, NewOpenList, NewLastId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint)


pathFinding_addRightCase(Map, ParentId, Info, NewInfo)
:- getCurrentCasePosInNavMap(Map, [X, Y]),     % on rcup la position
   NewX is X + 1,                              % on incrmente X (vers la droite)
   mapNavigateTo(Map, [NewX, Y], NewMap),      % on se dplace vers la droite
   pathFinding_tryAddCase(NewMap, ParentId, right, Info, NewInfo), !.


/* ------------------------------------------------
   Ajoute la case du bas  la Open List */

   % pathFinding_addBottomCase(Map, ParentId, Destination, OpenList, CloseList, LastId, NewOpenList, NewLastId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint)


pathFinding_addBottomCase(Map, ParentId, Info, NewInfo)
:- getCurrentCasePosInNavMap(Map, [X, Y]),     % on rcup la position
   NewY is Y + 1,                              % on incrmente Y (vers le bas)
   mapNavigateTo(Map, [X, NewY], NewMap),      % on se dplace vers le bas
   pathFinding_tryAddCase(NewMap, ParentId, down, Info, NewInfo), !.
   

/* ------------------------------------------------
   Ajoute la case courante (pas de mouvement)  la Open List */

   % pathFinding_addCurrentCase(Map, ParentId, Info, NewInfo)
   
   
pathFinding_addCurrentCase(Map, ParentId, Info, NewInfo)
:- pathFinding_tryAddCase(Map, ParentId, here, Info, NewInfo), !.


/***********************************************************
** pathFinding_element.pl
***********/


/* ------------------------------------------------
   Get informations from Path Finding list */

% pathFinding(PathFindingInfos)

pathFinding_getDestination(      [ Destination | _ ], Destination).
pathFinding_getOpenList(         [_, OpenList | _ ], OpenList).
pathFinding_getCloseList(        [_, _, CloseList | _ ], CloseList).
pathFinding_getWaitList(         [_, _, _, WaitList | _ ], WaitList).
pathFinding_getLastCaseId(       [_, _, _, _, LastCaseId | _ ], LastCaseId).
pathFinding_getLasMapId(         [_, _, _, _, _, LastMapId | _ ], LastMapId).
pathFinding_getCanGoToNearTarget([_, _, _, _, _, _, CanGoToNearTarget | _ ], CanGoToNearTarget).
pathFinding_getMustBeAbleToLeave([_, _, _, _, _, _, _, MustBeAbleToLeave | _ ], MustBeAbleToLeave).
pathFinding_getBreakPoint(       [_, _, _, _, _, _, _, _, BreakPoint | _ ], BreakPoint).
pathFinding_getWay(              [_, _, _, _, _, _, _, _, _, Way], Way).



% pathFinding_changeOpenAndCloseLists(Info, NewOpenList, NewCloseList, NewInfo)

pathFinding_changeOpenAndCloseLists(
[Destination, _, _, WaitList, LastCaseId, LastMapId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Way],
 NewOpenList, NewCloseList,
[Destination, NewOpenList, NewCloseList, WaitList, LastCaseId, LastMapId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Way]).


pathFinding_changeWaitAndCloseLists(
[Destination, NewOpenList, _, _, LastCaseId, LastMapId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Way],
 WaitList, NewCloseList,
[Destination, NewOpenList, NewCloseList, WaitList, LastCaseId, LastMapId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Way]).


% pathFinding_changeBreakPoint(Info, NewBreakPoint, NewInfo)

pathFinding_changeBreakPoint(
[Destination, OpenList, CloseList, WaitList, LastCaseId, LastMapId, CanGoToNearTarget, MustBeAbleToLeave, _, Way],
 BreakPoint,
[Destination, OpenList, CloseList, WaitList, LastCaseId, LastMapId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Way]).


pathFinding_changeOpenList(
[Destination, _, CloseList, WaitList, LastCaseId, LastMapId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Way],
 OpenList,
[Destination, OpenList, CloseList, WaitList, LastCaseId, LastMapId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Way]).


pathFinding_changeWaitList(
[Destination, OpenList, CloseList, _, LastCaseId, LastMapId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Way],
 WaitList,
[Destination, OpenList, CloseList, WaitList, LastCaseId, LastMapId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Way]).


pathFinding_changeLastMapId(
[Destination, OpenList, CloseList, WaitList, LastCaseId, _, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Way],
 LastMapId,
[Destination, OpenList, CloseList, WaitList, LastCaseId, LastMapId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Way]).


pathFinding_changeLastCaseId(
[Destination, OpenList, CloseList, WaitList, _, LastMapId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Way],
 LastCaseId,
[Destination, OpenList, CloseList, WaitList, LastCaseId, LastMapId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Way]).


pathFinding_changeWay(
[Destination, OpenList, CloseList, WaitList, LastCaseId, LastMapId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, _],
 Way,
[Destination, OpenList, CloseList, WaitList, LastCaseId, LastMapId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Way]).


/***********************************************************
** pathFinding_list.pl
***********/






/* ------------------------------------------------
   Create close list  */

   % pathfinding_createCloseList(StartMap, Destination, CloseList)

   % Close list element format : [ StartDist, FlyDist, ParentId, CaseId, MapId, MapFrame, Map, MapIsMoving ]

pathfinding_createCloseList(StartMap, MapIsMoving, Destination, [ [ 0, Dist, 0, 1, 1, 0, StartMap, MapIsMoving ] ])
:- getCurrentCasePosInNavMap(StartMap, Pos),
   getDist(Pos, Destination, DistFly),
   Dist is DistFly * 2, !.


/* ------------------------------------------------
   ajouter une case  une close list  */

   % pathFinding_addCaseInCloseList(CloseList, ParentId, CaseId, Map, NewCloseList)

% simple version /!\ use carefully
pathFinding_addCaseInCloseList(CloseList, ParentId, CaseId, Map, MapIsMoving, [ [ 0, 0, ParentId, CaseId, -1, -1, Map, MapIsMoving ] | CloseList ]).



/* ------------------------------------------------
   Rcuprer la derniere carte ajoute dans la Close List  */

   % pathFinding_getLastAddedMap(CloseList, Map)

pathFinding_getLastAddedMap([ [_ , _, _, _, _, _, Map | _ ] | _ ], Map).


/* ------------------------------------------------
   Rcuprer le dernier Id ajoute dans la Close List  */

   % pathFinding_getLastAddedId(CloseList, Id)


pathFinding_getLastAddedId([ [_ , _, _, Id | _ ] | _ ], Id).


/* ------------------------------------------------
   Rcuprer si le dernier element ajout tait une carte en mouvement  */

   % pathFinding_getLastAddedHasMoved(CloseList, HasMoved)


pathFinding_getLastAddedHasMoved([ [_ , _, _, _, _, _, _, HasMoved | _ ] | _ ], HasMoved).



/* ------------------------------------------------
   Rcuprer la distance au dpart de la derniere carte ajoute dans la Close List  */

   % pathFinding_getDistLastAddedMap(CloseList, Map)

pathFinding_getDistLastAddedMap([ [Dist | _ ] | _ ], Dist).


/* ------------------------------------------------
   la case est dj prsente dans les 2 listes avec des coefficients trop bas */

   % pathFinding_existInCloseList(Pos, Weight, CloseList)


% on trouve la case
pathFinding_existInCloseList(Pos, Weight, [ [Dist, DistFly, _, _, _, _, Map | _ ] | _ ])
:- getCurrentCasePosInNavMap(Map, Pos),      % meme position
   %maximumWeightSpace(Max),
   %(Dist + DistFly) < (Weight - Max), !.
   %(Dist + DistFly) < Weight, !.
   !.

pathFinding_existInCloseList(Pos, Weight, [ _ | R ])
:- pathFinding_existInCloseList(Pos, Weight, R), !.


pathFinding_existInOpenList(Pos, Weight, [ [Weight2, [_, _, _, _, _, _, Map | _ ]] | _ ])
:- getCurrentCasePosInNavMap(Map, Pos),      % meme position
   %maximumWeightSpace(Max),
   %(Weight2) < (Weight - Max), !.
   %Weight2 < Weight, !.
   !.

pathFinding_existInOpenList(Pos, Weight, [ _ | R ])
:- pathFinding_existInOpenList(Pos, Weight, R), !.


/* ------------------------------------------------
   supprime les cases de mme coordonnes avec des poids trop importants */

   % pathFinding_deleteInOpenList(Pos, Weight, OpenList, NewOpenList)


% meme position, poid trop important
pathFinding_deleteInOpenList(Pos, Weight, [ [Weight2, [_, _, _, _, _, _, Map | _ ]] | Rest ], NewOpenList)
:- getCurrentCasePosInNavMap(Map, Pos),      % meme position
   maximumWeightSpace(Max),
   (Weight2) > (Weight + Max),
   pathFinding_deleteInOpenList(Pos, Weight, Rest, NewOpenList), !.


% on ne retire pas la case
pathFinding_deleteInOpenList(Pos, Weight, [ T | Rest ], [ T | NewRest] )
:- pathFinding_deleteInOpenList(Pos, Weight, Rest, NewRest ), !.

% liste vide
pathFinding_deleteInOpenList(_, _, [], [] )
:- !.


/***********************************************************
** safeCase.pl
***********/


/* ------------------------------------------------
   cette case n'est pas scurise (monstre a proximite, boulet au dessus)  */

   % notSafeCase(Map)


% on se dplace voir la case du dessus
notSafeCase(Map)
:- getPreviousLineSameXInNavMap(Map, NewMap),
   notSafeCaseUp(NewMap), !.
   
   
% on se dplace voir la case de droite
notSafeCase(Map)
:- getNextCaseInNavMap(Map, NewMap),
   notSafeCaseRight(NewMap), !.
   
   
% on se dplace voir la case de gauche
notSafeCase(Map)
:- getPreviousCaseInNavMap(Map, NewMap),
   notSafeCaseLeft(NewMap), !.


% on se dplace voir la case du dessous
notSafeCase(Map)
:- getNextLineSameXInNavMap(Map, NewMap),
   notSafeCaseDown(NewMap), !.
   
   




% la case du dessus est un monstre
notSafeCaseUp(Map)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, monstre), !.



% la case du dessus est vide, on se dplace voir encore au dessus
notSafeCaseUp(Map)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, vide),
   getPreviousLineSameXInNavMap(Map, NewMap),
   notSafeCaseUpUp(NewMap), !.


% la case du dessus est vide, on va voir a gauche s'il n'y a pas un monstre qui va a droite ou en bas
notSafeCaseUp(Map)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, vide),                % la case du haut est vide
   getPreviousCaseInNavMap(Map, NewMap),   % rcuprer la case en haut  gauche
   getCurrentCaseInNavMap(NewMap, NewCase),
   getCaseType(NewCase, monstre),          % cette case est un monstre
   getMonsterFromCase(NewCase, Monster),
   (monsterIsRightOrUnknown(Monster) ; monsterIsDownOrUnknown(Monster)), !.    % ce monstre va vers la droite ou le bas


% la case du dessus est vide, on va voir a droite s'il n'y a pas un monstre qui va a gauche ou en bas
notSafeCaseUp(Map)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, vide),                % la case du haut est vide
   getNextCaseInNavMap(Map, NewMap),       % rcuprer la case en haut  droite
   getCurrentCaseInNavMap(NewMap, NewCase),
   getCaseType(NewCase, monstre),          % cette case est un monstre
   getMonsterFromCase(NewCase, Monster),
   (monsterIsLeftOrUnknown(Monster) ; monsterIsDownOrUnknown(Monster)), !.     % ce monstre va vers la gauche ou le bas


% la case du dessus dessus est un boulet ou un diamant
notSafeCaseUpUp(Map)
:- getCurrentCaseInNavMap(Map, Case),
   ( getCaseType(Case, pierre) ; getCaseType(Case, diam) ), !.


% la case du dessus dessus est un monstre qui va vers le bas ou qui n'a pas de direction
notSafeCaseUpUp(Map)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, monstre),
   getMonsterFromCase(Case, Monster),
   monsterIsDownOrUnknown(Monster), !.







% la case du dessous est un monstre
notSafeCaseDown(Map)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, monstre), !.


% la case du dessous est vide, on se dplace voir encore au dessous
notSafeCaseDown(Map)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, vide),
   getNextLineSameXInNavMap(Map, NewMap),
   notSafeCaseDownDown(NewMap), !.


% la case du dessous est vide, on va voir a gauche s'il n'y a pas un monstre qui va a droite ou en haut
notSafeCaseDown(Map)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, vide),                % la case du dessous est vide
   getPreviousCaseInNavMap(Map, NewMap),   % rcuprer la case en bas  gauche
   getCurrentCaseInNavMap(NewMap, NewCase),
   getCaseType(NewCase, monstre),          % cette case est un monstre
   getMonsterFromCase(NewCase, Monster),
   (monsterIsRightOrUnknown(Monster) ; monsterIsTopOrUnknown(Monster)), !.    % ce monstre va vers la droite ou le haut


% la case du dessous est vide, on va voir a droite s'il n'y a pas un monstre qui va a gauche ou en haut
notSafeCaseDown(Map)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, vide),                % la case du bas est vide
   getNextCaseInNavMap(Map, NewMap),       % rcuprer la case en bas  droite
   getCurrentCaseInNavMap(NewMap, NewCase),
   getCaseType(NewCase, monstre),          % cette case est un monstre
   getMonsterFromCase(NewCase, Monster),
   (monsterIsLeftOrUnknown(Monster) ; monsterIsTopOrUnknown(Monster)), !.     % ce monstre va vers la gauche ou le haut


% la case du dessous dessous est un monstre qui va vers le haut ou qui n'a pas de direction
notSafeCaseDownDown(Map)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, monstre),
   getMonsterFromCase(Case, Monster),
   monsterIsTopOrUnknown(Monster), !.







% la case de gauche est un monstre
notSafeCaseLeft(Map)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, monstre), !.


% la case de gauche est vide, on se dplace voir encore  gauche
notSafeCaseLeft(Map)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, vide),
   getPreviousCaseInNavMap(Map, NewMap),
   notSafeCaseLeftLeft(NewMap), !.


% la case de gauche gauche est un monstre qui va vers la droite ou qui n'a pas de direction
notSafeCaseLeftLeft(Map)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, monstre),
   getMonsterFromCase(Case, Monster),
   monsterIsRightOrUnknown(Monster), !.








% la case de droite est un monstre
notSafeCaseRight(Map)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, monstre), !.


% la case de droite est vide, on se dplace voir encore  droite
notSafeCaseRight(Map)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, vide),
   getNextCaseInNavMap(Map, NewMap),
   notSafeCaseRightRight(NewMap), !.


% la case de droite droite est un monstre qui va vers la gauche ou qui n'a pas de direction
notSafeCaseRightRight(Map)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, monstre),
   getMonsterFromCase(Case, Monster),
   monsterIsLeftOrUnknown(Monster), !.


/***********************************************************
** updateMap.pl
***********/


/* ------------------------------------------------
   Crer la carte de l'image courante en fonction de l'image prcdente */

   %  updateMap(ListMap, OldNavMap, NewNavMap)

updateMap(ListMap, OldNavMap, NewNavMap)
:- getMapSize( [Width, _]),
   dealList(ListMap, Width, Width, SimpleMap, 1),
   getNavigateMap(SimpleMap, [1,1], NewNavMap), !.
   % .............. TODO ................
   % traiter les directions des monstres
