/* ------------------------------------------------
   get the closer target position */

   % getCloserTarget(NavigableMap, Pos, CloserTarget)
   % getCloserTarget(NavigableMap, Pos, CloserTarget, AllFoundedTargets, BestDist)
   
% essai : dealList([1, 1, 1, 1, 1, 1, 1, 2, 1], 3, M), getNavigateMap(M, [1, 1], NM), getCloserTarget(NM, [1, 1], Target).

getCloserTarget(Map, Pos, CloserTarget)
:- mapNavigateTo(Map, Pos, NewMap),
   debugN_fct('-------------'),
   getCloserTarget(NewMap, NewMap, Pos, CloserTarget, [100000, 100000]), !.


% Si on est plus  gauche de la  case d'origine que la meilleur distance, pas la peine de continuer, on passe  la ligne du dessous
getCloserTarget(OriginMap, NavMap, [OX, OY], CloserTarget, BestPos)
:- getDist([OX, OY], BestPos, BestDist),
   getCurrentCasePosInNavMap(NavMap, [CX, _]),
   (CX - OX) > BestDist,
   debugN_fct('trop  gauche'),
   getCloserTarget_nextLine(OriginMap, NavMap, [OX, OY], CloserTarget, BestPos), !.

% On doit tester la case
getCloserTarget(OriginMap, NavMap, OPos, CloserTarget, BestPos)
:- getCurrentCaseAndPosInNavMap(NavMap, Case, [X, Y]),
   debug_fct('test case : '), debug_fct(X), debug_fct(' '), debug_fct(Y), debug_fct(' : '), getCaseType(Case, TT), debugN_fct(TT),
   getCloserTarget_addCase(Case, OPos, [X, Y], BestPos, NewBestPos),
   getCloserTarget_nextCase(OriginMap, NavMap, OPos, CloserTarget, NewBestPos), !.



% Si on est plus  gauche de la  case d'origine que la meilleur distance, pas la peine de continuer, on passe  la ligne du dessus
getCloserTargetReverse(OriginMap, NavMap, [OX, OY], CloserTarget, BestPos)
:- getDist([OX, OY], BestPos, BestDist),
   getCurrentCasePosInNavMap(NavMap, [CX, CY]),
   (OX - CX) > BestDist,
   debugN_fct('trop  droite : '), debugN_fct([CX, CY]),
   getCloserTarget_previousLine(OriginMap, NavMap, [OX, OY], CloserTarget, BestPos), !.

% On doit tester la case
getCloserTargetReverse(OriginMap, NavMap, OPos, CloserTarget, BestPos)
:- getCurrentCaseAndPosInNavMap(NavMap, Case, Pos),
   debug_fct('test case : '), debug_fct(Pos), debug_fct(' : '), getCaseType(Case, TT), debugN_fct(TT),
   getCloserTarget_addCase(Case, OPos, Pos, BestPos, NewBestPos),
   getCloserTarget_previousCase(OriginMap, NavMap, OPos, CloserTarget, NewBestPos), !.




% Si on est plus bas de la case d'origine que la meilleur distance, pas la peine de descendre plus bas, on va chercher en haut
getCloserTarget_nextLine(OriginMap, NavMap, [OX, OY], CloserTarget, BestPos)
:- getDist([OX, OY], BestPos, BestDist),
   getCurrentCasePosInNavMap(NavMap, [_, CY]),
   (CY - OY) > BestDist,
   debugN_fct('on est trop bas'),
   getCloserTargetReverse(OriginMap, OriginMap, [OX, OY], CloserTarget, BestPos), !.

% Sinon on va a la ligne suivante
getCloserTarget_nextLine(OriginMap, NavMap, OPos, CloserTarget, BestPos)
:- getNextLineInNavMap(NavMap, NewNavMap),
   debugN_fct('on va a la ligne suivante'),
   getCloserTarget(OriginMap, NewNavMap, OPos, CloserTarget, BestPos), !.

% S'il n'y a pas de ligne suivante on cherche vers le haut
getCloserTarget_nextLine(OriginMap, _, OPos, CloserTarget, BestPos)
:- debugN_fct('fin de carte'), getCloserTargetReverse(OriginMap, OriginMap, OPos, CloserTarget, BestPos), !.



% Si on est plus haut de la case d'origine que la meilleur distance, pas la peine de monter plus haut, on arrete de chercher
getCloserTarget_previousLine(_, NavMap, [OX, OY], BestPos, BestPos)
:- getDist([OX, OY], BestPos, BestDist),
   getCurrentCasePosInNavMap(NavMap, [_, CY]),
   (OY - CY) > BestDist, !.

% Sinon on va a la ligne precedente
getCloserTarget_previousLine(OriginMap, NavMap, OPos, CloserTarget, BestPos)
:- getPreviousLineEndInNavMap(NavMap, NewNavMap),
   getCloserTargetReverse(OriginMap, NewNavMap, OPos, CloserTarget, BestPos), !.

% S'il n'y a pas de ligne precedente, on a fini
getCloserTarget_previousLine(_, _, _, BestPos, BestPos) :-  !.



% On va a la case suivante si on peut
getCloserTarget_nextCase(OriginMap, NavMap, OPos, CloserTarget, BestPos)
:- getNextCaseInNavMap(NavMap, NewNavMap),
   debugN_fct('ok next'),
   getCloserTarget(OriginMap, NewNavMap, OPos, CloserTarget, BestPos), !.

% sinon on va a la ligne suivante
getCloserTarget_nextCase(OriginMap, NavMap, OPos, CloserTarget, BestPos)
:- debugN_fct('fail next'),
   getCloserTarget_nextLine(OriginMap, NavMap, OPos, CloserTarget, BestPos), !.



% On va a la case prcdente si on peut
getCloserTarget_previousCase(OriginMap, NavMap, OPos, CloserTarget, BestPos)
:- getPreviousCaseInNavMap(NavMap, NewNavMap),
   getCloserTargetReverse(OriginMap, NewNavMap, OPos, CloserTarget, BestPos), !.

% sinon on va a la ligne prcdente
getCloserTarget_previousCase(OriginMap, NavMap, OPos, CloserTarget, BestPos)
:- getCloserTarget_previousLine(OriginMap, NavMap, OPos, CloserTarget, BestPos), !.





% Si la case est un objectif et plus pret que l'obj courant, changer la position de l'obj courant
getCloserTarget_addCase(Case, Origin, [X, Y], BestPos, [X, Y])
:- caseIsTarget(Case),
   getCaseType(Case, Type),
   debug_fct('case type : '),
   debugN_fct(Type),
   debug_fct('on ajoute la case : '),
   debug_fct(X),
   debug_fct(' '),
   debugN_fct(Y),
   getDist(Origin, [X, Y], Dist),
   getDist(Origin, BestPos, BestDist),
   Dist < BestDist, !.

% Sinon la nouvelle position n'a pas chang
getCloserTarget_addCase(_, _, _, BestPos, BestPos) :- !.