/* ------------------------------------------------
   Permet de savoir si le joueur s'est dplac sans IA ou si la carte a chang */

   %  mapHasChanged(PosMineur, LargeurCarte)

% Si on ne connait pas la position du mineur, la carte a chang (on lance l'IA pour la premire fois de la session)
mapHasChanged(_, _) :- not(recorded(oldMineurPosition, _)), debugN('on ne connait pas la position du mineur'), !.

% Si le mineur s'est loign de plus d'une case de son ancienne position, la carte a chang
mapHasChanged(PosMineur, _)
:- recorded(oldMineurPosition, OldMineurPosition),
   debug('ancienne pos :'),
   debugN(OldMineurPosition),
   debug('nouvelle pos :'),
   debugN(PosMineur),
   not(isNear(OldMineurPosition, PosMineur)), debugN('le mineur s''est trop dplac'), !.

% Si on n'a pas de carte enregistre, la carte a chang
mapHasChanged(_, _) :- not(recorded(map, _)), debugN('on n''a pas de carte enregistr'), !.

% Si la carte a chang de largeur, elle a chang
mapHasChanged(_, Size)
:- getMapSize([Largeur, _]),
   Largeur \= Size,
   debug('la largeur a chang :'), debugN(Largeur), !.

% Si la carte a chang de hauteur, elle a chang
% ne peut pas etre su si facilement ... pas grave
% on estime que les cas prcdents suffisent pour savoir si la carte a chang


/* ------------------------------------------------
   Permet de savoir si on arriver sur une nouvelle carte, ou si on s'est dplac manuellement */

   % mustDealMap(MinerPos, Width)

mustDealMap(_, _)
:- recorded(mustDealMap, true), debugN('mustDealMap is true'), !.

mustDealMap(MinerPos, Width)
:- mapHasChanged(MinerPos, Width), debugN('mapHasChanged is true'), !.
