/* ------------------------------------------------
   make a navigable map from a simple map */

   % getNavigateMap(Map, Pos, NavigationMap)
   
% essai : dealList([2, 1, 1, 1, 1, 1, 1, 1, 1], 3, M), getNavigateMap(M, [1, 1], NM).

getNavigateMap([[C| CR] | LR], Pos, NavigationMap)
:- mapNavigateTo([[0, 0], [], [], C, CR, LR], Pos, NavigationMap), !.


/* ------------------------------------------------
   Changer la case courante */
   
   % setCurrentCaseInNavMap(Map, NewCase, NewMap)

setCurrentCaseInNavMap([Pos, BeforeLines, BeforeCases, _ | R], Case, [Pos, BeforeLines, BeforeCases, Case | R]).



/* ------------------------------------------------
   Navigate on a navigable map */

   % mapNavigateTo([CurrentPos, BeforeLines, BeforeCases, CurrentCase, AfterCases, AfterLines], PosToGo, NavigationMap)

% il faut descendre
mapNavigateTo( [[_, Yc], BeforeLines, BeforeCases, CurrentCase, AfterCases, [ [FirstCase | NextCases] | AfterLines] ], [X, Y], NavigationMap)
:- Y > Yc,
   lineNavigateUnifyLine(BeforeCases, CurrentCase, AfterCases, Line),
   NewYc is Yc + 1,
   mapNavigateTo( [[0, NewYc], [Line | BeforeLines], [], FirstCase, NextCases, AfterLines], [X, Y], NavigationMap), !.


% il faut monter
mapNavigateTo( [[_, Yc], [[FirstCase | NextCases] | BeforeLines], BeforeCases, CurrentCase, AfterCases, AfterLines ], [X, Y], NavigationMap)
:- Y < Yc,
   lineNavigateUnifyLine(BeforeCases, CurrentCase, AfterCases, Line),
   NewYc is Yc - 1,
   mapNavigateTo( [[0, NewYc], BeforeLines, [], FirstCase, NextCases, [Line | AfterLines] ], [X, Y], NavigationMap), !.


% il faut aller a gauche
mapNavigateTo( [[Xc, Y], BeforeLines, [C | BeforeCases], CurrentCase, AfterCases, AfterLines ], [X, Y], NavigationMap)
:- X < Xc,
   NewXc is Xc - 1,
   mapNavigateTo( [[NewXc, Y], BeforeLines, BeforeCases, C, [CurrentCase| AfterCases], AfterLines ], [X, Y], NavigationMap), !.


% il faut aller a droite
mapNavigateTo( [[Xc, Y], BeforeLines, BeforeCases, CurrentCase, [C | AfterCases], AfterLines ], [X, Y], NavigationMap)
:- X > Xc,
   NewXc is Xc + 1,
   mapNavigateTo([[NewXc, Y], BeforeLines, [CurrentCase | BeforeCases], C, AfterCases, AfterLines ], [X, Y], NavigationMap), !.


% nous avons la case
mapNavigateTo([[X, Y] | R], [X, Y], [[X, Y] | R]) :- !.


/* ------------------------------------------------
   get a uniq line from navigation line */

   % lineNavigateUnifyLine(BeforeCases, CurrentCase, AfterCases, Line)


lineNavigateUnifyLine([T | BeforeCases], CurrentCase, AfterCases, Line)
:- lineNavigateUnifyLine(BeforeCases, T, [CurrentCase | AfterCases], Line), !.

lineNavigateUnifyLine([], Current, AfterCases, [Current | AfterCases]) :- !.


/* ------------------------------------------------
   get the current position of a navigate map */

   % getCurrentCasePosInNavMap(NavMap, Pos)

getCurrentCasePosInNavMap([Pos | _], Pos).


/* ------------------------------------------------
   get the current case and position of a navigate map */

   % getCurrentCaseAndPosInNavMap(NavMap, Case, Pos)

getCurrentCaseAndPosInNavMap([Pos, _, _, Case | _], Case, Pos).


/* ------------------------------------------------
   get the current case of a navigate map */

   % getCurrentCaseInNavMap(NavMap, Case, Pos)

getCurrentCaseInNavMap([ _, _, _, Case | _], Case).


/* ------------------------------------------------
   get the next line in a navigate map */

   % getNextLineInNavMap(NavMap, NewNavMap)

getNextLineInNavMap([ [X, Y] | NavMap], NewNavMap)
:- recorded(mapSize, [_, Height]),
   NewY is Y + 1,
   NewY < Height,
   mapNavigateTo([ [X, Y] | NavMap], [0, NewY], NewNavMap), !.


/* ------------------------------------------------
   get the previous line in a navigate map */

   % getPreviousLineInNavMap(NavMap, NewNavMap)

getPreviousLineInNavMap([ [X, Y] | NavMap], NewNavMap)
:- Y > 0,
   NewY is Y - 1,
   mapNavigateTo([ [X, Y] | NavMap], [0, NewY], NewNavMap), !.


/* ------------------------------------------------
   get the previous line in a navigate map and go to the end of line */

   % getPreviousLineEndInNavMap(NavMap, NewNavMap)

getPreviousLineEndInNavMap([ [X, Y] | NavMap], NewNavMap)
:- Y > 0,
   NewY is Y - 1,
   recorded(mapSize, [Width, _]),
   NewX is Width - 1,
   mapNavigateTo([ [X, Y] | NavMap], [NewX, NewY], NewNavMap), !.


/* ------------------------------------------------
   get the next case in a navigate map */

   % getNextCaseInNavMap(NavMap, NewNavMap)

getNextCaseInNavMap([ [X, Y] | NavMap], NewNavMap)
:- recorded(mapSize, [Weith, _]),
   NewX is X + 1,
   NewX < Weith,
   mapNavigateTo([ [X, Y] | NavMap], [NewX, Y], NewNavMap), !.
   


/* ------------------------------------------------
   get the next case in a navigate map, but go to the line instead of failing if we are at the end of the line */

   % getNextListCaseInNavMap(NavMap, NewNavMap)
   
getNextListCaseInNavMap(Map, NewMap)
:- getNextCaseInNavMap(Map, NewMap), !.

getNextListCaseInNavMap(Map, NewMap)
:- getNextLineInNavMap(Map, NewMap), !.


/* ------------------------------------------------
   get the previous case in a navigate map */

   % getPreviousCaseInNavMap(NavMap, NewNavMap)

getPreviousCaseInNavMap([ [X, Y] | NavMap], NewNavMap)
:- X > 0,
   NewX is X - 1,
   mapNavigateTo([ [X, Y] | NavMap], [NewX, Y], NewNavMap), !.
   
   
/* ------------------------------------------------
   get the next line in a navigate map with same X */

   % getNextLineSameXInNavMap(NavMap, NewNavMap)

getNextLineSameXInNavMap([ [X, Y] | NavMap], NewNavMap)
:- recorded(mapSize, [_, Height]),
   NewY is Y + 1,
   NewY < Height,
   mapNavigateTo([ [X, Y] | NavMap], [X, NewY], NewNavMap), !.
   

/* ------------------------------------------------
   get the previous line in a navigate map with same X */

   % getPreviousLineSameXInNavMap(NavMap, NewNavMap)

getPreviousLineSameXInNavMap([ [X, Y] | NavMap], NewNavMap)
:- Y > 0,
   NewY is Y - 1,
   mapNavigateTo([ [X, Y] | NavMap], [X, NewY], NewNavMap), !.
   
   
/* ------------------------------------------------
   se dplacer dans une direction donne */

   % mapNavigatePushTo(Map, Direction, NewMap)
   
mapNavigatePushTo(Map, up, NewMap)
:- getPreviousLineSameXInNavMap(Map, NewMap), !.

mapNavigatePushTo(Map, down, NewMap)
:- getNextLineSameXInNavMap(Map, NewMap), !.

mapNavigatePushTo(Map, left, NewMap)
:- getPreviousCaseInNavMap(Map, NewMap), !.

mapNavigatePushTo(Map, right, NewMap)
:- getNextCaseInNavMap(Map, NewMap), !.
   
