/* ------------------------------------------------
   Get informations from Path Finding list */

% pathFinding(PathFindingInfos)

pathFinding_getDestination(      [ Destination | _ ], Destination).
pathFinding_getOpenList(         [_, OpenList | _ ], OpenList).
pathFinding_getCloseList(        [_, _, CloseList | _ ], CloseList).
pathFinding_getWaitList(         [_, _, _, WaitList | _ ], WaitList).
pathFinding_getLastCaseId(       [_, _, _, _, LastCaseId | _ ], LastCaseId).
pathFinding_getLasMapId(         [_, _, _, _, _, LastMapId | _ ], LastMapId).
pathFinding_getCanGoToNearTarget([_, _, _, _, _, _, CanGoToNearTarget | _ ], CanGoToNearTarget).
pathFinding_getMustBeAbleToLeave([_, _, _, _, _, _, _, MustBeAbleToLeave | _ ], MustBeAbleToLeave).
pathFinding_getBreakPoint(       [_, _, _, _, _, _, _, _, BreakPoint | _ ], BreakPoint).
pathFinding_getWay(              [_, _, _, _, _, _, _, _, _, Way], Way).



% pathFinding_changeOpenAndCloseLists(Info, NewOpenList, NewCloseList, NewInfo)

pathFinding_changeOpenAndCloseLists(
[Destination, _, _, WaitList, LastCaseId, LastMapId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Way],
 NewOpenList, NewCloseList,
[Destination, NewOpenList, NewCloseList, WaitList, LastCaseId, LastMapId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Way]).


pathFinding_changeWaitAndCloseLists(
[Destination, NewOpenList, _, _, LastCaseId, LastMapId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Way],
 WaitList, NewCloseList,
[Destination, NewOpenList, NewCloseList, WaitList, LastCaseId, LastMapId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Way]).


% pathFinding_changeBreakPoint(Info, NewBreakPoint, NewInfo)

pathFinding_changeBreakPoint(
[Destination, OpenList, CloseList, WaitList, LastCaseId, LastMapId, CanGoToNearTarget, MustBeAbleToLeave, _, Way],
 BreakPoint,
[Destination, OpenList, CloseList, WaitList, LastCaseId, LastMapId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Way]).


pathFinding_changeOpenList(
[Destination, _, CloseList, WaitList, LastCaseId, LastMapId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Way],
 OpenList,
[Destination, OpenList, CloseList, WaitList, LastCaseId, LastMapId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Way]).


pathFinding_changeWaitList(
[Destination, OpenList, CloseList, _, LastCaseId, LastMapId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Way],
 WaitList,
[Destination, OpenList, CloseList, WaitList, LastCaseId, LastMapId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Way]).


pathFinding_changeLastMapId(
[Destination, OpenList, CloseList, WaitList, LastCaseId, _, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Way],
 LastMapId,
[Destination, OpenList, CloseList, WaitList, LastCaseId, LastMapId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Way]).


pathFinding_changeLastCaseId(
[Destination, OpenList, CloseList, WaitList, _, LastMapId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Way],
 LastCaseId,
[Destination, OpenList, CloseList, WaitList, LastCaseId, LastMapId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Way]).


pathFinding_changeWay(
[Destination, OpenList, CloseList, WaitList, LastCaseId, LastMapId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, _],
 Way,
[Destination, OpenList, CloseList, WaitList, LastCaseId, LastMapId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Way]).